// InfoListCtrl.cpp: implementation of the CInfoListCtrl class.
// (p) 2002 by FoRcHa (a.k.a. NO)  [seppforcher38@hotmail.com]
/////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "emule.h"
#include "InfoListCtrl.h"
#include "otherfunctions.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CInfoListCtrl::CInfoListCtrl()
{
	m_bClear = true;
	
	m_file = NULL;
	m_client = NULL;
	m_bUser = TRUE;

	for(int i = 0; i < 3; i++)
		m_bExpandedUser[i] = true;
	for(int i = 0; i < 2; i++)
		m_bExpandedFile[i] = true;

	m_crEntryTextColor = RGB(0,45,126);
}

CInfoListCtrl::~CInfoListCtrl()
{
	
}

BEGIN_MESSAGE_MAP(CInfoListCtrl, COptionTree)
	//{{AFX_MSG_MAP(CInfoListCtrl)
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_WM_SHOWWINDOW()
END_MESSAGE_MAP()

void CInfoListCtrl::ReCreateList(BOOL bUserData)
{	
//	SetRedraw(FALSE);	 SetRedraw makes some troubles with scrollbar redraw/update :(

	bool bWasWindowVisible = IsWindowVisible();
	if(bWasWindowVisible)
		ShowWindow(SW_HIDE);	// until i find a better solution
	
	DeleteAllItems();

	if(bUserData)
	{			
		UserData.General = InsertItem(new COptionTreeItem);
		UserData.General->SetLabelText(GetResString(IDS_INFLST_USER_GENERAL));
		UserData.General->Expand(m_bExpandedUser[0]);
		UserData.UserName = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.General);
		UserData.UserName->SetLabelText(GetResString(IDS_INFLST_USER_USERNAME));
		if(UserData.UserName->CreateStaticItem(0))
			UserData.UserName->SetTextColor(m_crEntryTextColor);
		UserData.UserHash = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.General);
		UserData.UserHash->SetLabelText(GetResString(IDS_INFLST_USER_USERHASH));
		if(UserData.UserHash->CreateStaticItem(0))
			UserData.UserHash->SetTextColor(m_crEntryTextColor);
		UserData.ClientSoftware = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.General);
		UserData.ClientSoftware->SetLabelText(GetResString(IDS_INFLST_USER_CLIENTSOFTWARE));
		if(UserData.ClientSoftware->CreateStaticItem(0))
			UserData.ClientSoftware->SetTextColor(m_crEntryTextColor);
		UserData.ClientVersion = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.General);
		UserData.ClientVersion->SetLabelText(GetResString(IDS_INFLST_USER_CLIENTVERSION));
		if(UserData.ClientVersion->CreateStaticItem(0))
			UserData.ClientVersion->SetTextColor(m_crEntryTextColor);
		UserData.IPAddress = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.General);
		UserData.IPAddress->SetLabelText(GetResString(IDS_INFLST_USER_IPADDRESS));
		if(UserData.IPAddress->CreateStaticItem(0))
			UserData.IPAddress->SetTextColor(m_crEntryTextColor);
		UserData.ID = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.General);
		UserData.ID->SetLabelText(GetResString(IDS_INFLST_USER_ID));
		if(UserData.ID->CreateStaticItem(0))
			UserData.ID->SetTextColor(m_crEntryTextColor);
		UserData.ServerIP = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.General);
		UserData.ServerIP->SetLabelText(GetResString(IDS_INFLST_USER_SERVERIP));
		if(UserData.ServerIP->CreateStaticItem(0))
			UserData.ServerIP->SetTextColor(m_crEntryTextColor);
		UserData.ServerName = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.General);
		UserData.ServerName->SetLabelText(GetResString(IDS_INFLST_USER_SERVERNAME));
		if(UserData.ServerName->CreateStaticItem(0))
			UserData.ServerName->SetTextColor(m_crEntryTextColor);

		UserData.Transfer = InsertItem(new COptionTreeItem);
		UserData.Transfer->SetLabelText(GetResString(IDS_INFLST_USER_TRANSFER));
		UserData.Transfer->Expand(m_bExpandedUser[1]);
		UserData.CurDownloading = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.Transfer);
		UserData.CurDownloading->SetLabelText(GetResString(IDS_INFLST_USER_CURDOWNLOAD));
		if(UserData.CurDownloading->CreateStaticItem(0))
			UserData.CurDownloading->SetTextColor(m_crEntryTextColor);
		UserData.DownloadedSession = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.Transfer);
		UserData.DownloadedSession->SetLabelText(GetResString(IDS_INFLST_USER_SESSIONDOWNLOAD));
		if(UserData.DownloadedSession->CreateStaticItem(0))
			UserData.DownloadedSession->SetTextColor(m_crEntryTextColor);
		UserData.UploadedSession = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.Transfer);
		UserData.UploadedSession->SetLabelText(GetResString(IDS_INFLST_USER_SESSIONUPLOAD));
		if(UserData.UploadedSession->CreateStaticItem(0))
			UserData.UploadedSession->SetTextColor(m_crEntryTextColor);
		UserData.AverageDownloadrate = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.Transfer);
		UserData.AverageDownloadrate->SetLabelText(GetResString(IDS_INFLST_USER_AVERAGEDOWNRATE));
		if(UserData.AverageDownloadrate->CreateStaticItem(0))
			UserData.AverageDownloadrate->SetTextColor(m_crEntryTextColor);
		UserData.AverageUploadrate = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.Transfer);
		UserData.AverageUploadrate->SetLabelText(GetResString(IDS_INFLST_USER_AVERAGEUPRATE));
		if(UserData.AverageUploadrate->CreateStaticItem(0))
			UserData.AverageUploadrate->SetTextColor(m_crEntryTextColor);
		UserData.DownloadedTotal = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.Transfer);
		UserData.DownloadedTotal->SetLabelText(GetResString(IDS_INFLST_USER_TOTALDOWNLOAD));
		if(UserData.DownloadedTotal->CreateStaticItem(0))
			UserData.DownloadedTotal->SetTextColor(m_crEntryTextColor);
		UserData.UploadedTotal = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.Transfer);
		UserData.UploadedTotal->SetLabelText(GetResString(IDS_INFLST_USER_TOTALUPLOAD));
		if(UserData.UploadedTotal->CreateStaticItem(0))
			UserData.UploadedTotal->SetTextColor(m_crEntryTextColor);

		UserData.Scores = InsertItem(new COptionTreeItem);
		UserData.Scores->SetLabelText(GetResString(IDS_INFLST_USER_SCORES));
		UserData.Scores->Expand(m_bExpandedUser[2]);
		UserData.DlUpModifier = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.Scores);
		UserData.DlUpModifier->SetLabelText(GetResString(IDS_INFLST_USER_DLUPMODIFIER));
		if(UserData.DlUpModifier->CreateStaticItem(0))
			UserData.DlUpModifier->SetTextColor(m_crEntryTextColor);
		UserData.CommunityUser = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.Scores);
		UserData.CommunityUser->SetLabelText(GetResString(IDS_INFLST_USER_COMMUNITY));
		if(UserData.CommunityUser->CreateStaticItem(0))
			UserData.CommunityUser->SetTextColor(m_crEntryTextColor);
		UserData.Rating = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.Scores);
		UserData.Rating->SetLabelText(GetResString(IDS_INFLST_USER_RATING));
		if(UserData.Rating->CreateStaticItem(0))
			UserData.Rating->SetTextColor(m_crEntryTextColor);
		UserData.UploadQueueScore = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.Scores);
		UserData.UploadQueueScore->SetLabelText(GetResString(IDS_INFLST_USER_UPLOADQUEUESCORE));
		if(UserData.UploadQueueScore->CreateStaticItem(0))
			UserData.UploadQueueScore->SetTextColor(m_crEntryTextColor);

		//By Maverick
		UserData.RFRatio = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.Scores);
		UserData.RFRatio->SetLabelText(GetResString(IDS_INFLST_USER_RFRATIO));
		if(UserData.RFRatio->CreateStaticItem(0))
			UserData.RFRatio->SetTextColor(m_crEntryTextColor);
		UserData.SFRatio = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.Scores);
		UserData.SFRatio->SetLabelText(GetResString(IDS_INFLST_USER_SFRATIO));
		if(UserData.SFRatio->CreateStaticItem(0))
			UserData.SFRatio->SetTextColor(m_crEntryTextColor);

		UserData.RemoteScores = InsertItem(new COptionTreeItem);
		UserData.RemoteScores->SetLabelText(GetResString(IDS_INFLST_REMOTE_SCORES));
		UserData.RemoteScores->Expand(m_bExpandedUser[3]);
		UserData.RemoteDlUpModifier = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.RemoteScores);
		UserData.RemoteDlUpModifier->SetLabelText(GetResString(IDS_INFLST_USER_DLUPMODIFIER));
		if(UserData.RemoteDlUpModifier->CreateStaticItem(0))
			UserData.RemoteDlUpModifier->SetTextColor(m_crEntryTextColor);
		UserData.RemoteCommunityUser = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.RemoteScores);
		UserData.RemoteCommunityUser->SetLabelText(GetResString(IDS_INFLST_USER_COMMUNITY));
		if(UserData.RemoteCommunityUser->CreateStaticItem(0))
			UserData.RemoteCommunityUser->SetTextColor(m_crEntryTextColor);
		UserData.RemoteRating = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.RemoteScores);
		UserData.RemoteRating->SetLabelText(GetResString(IDS_INFLST_USER_RATING));
		if(UserData.RemoteRating->CreateStaticItem(0))
			UserData.RemoteRating->SetTextColor(m_crEntryTextColor);
		UserData.RemoteUploadQueueScore = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.RemoteScores);
		UserData.RemoteUploadQueueScore->SetLabelText(GetResString(IDS_INFLST_USER_UPLOADQUEUESCORE));
		if(UserData.RemoteUploadQueueScore->CreateStaticItem(0))
			UserData.RemoteUploadQueueScore->SetTextColor(m_crEntryTextColor);
		UserData.RemoteQueueRank = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.RemoteScores);
		UserData.RemoteQueueRank->SetLabelText(GetResString(IDS_INFLST_REMOTE_RANKING));
		if(UserData.RemoteQueueRank->CreateStaticItem(0))
			UserData.RemoteQueueRank->SetTextColor(m_crEntryTextColor);
		UserData.RemoteClientSpeed = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, UserData.RemoteScores);
		UserData.RemoteClientSpeed->SetLabelText(GetResString(IDS_INFLST_REMOTE_SPEED));
		if(UserData.RemoteClientSpeed->CreateStaticItem(0))
			UserData.RemoteClientSpeed->SetTextColor(m_crEntryTextColor);
	}
	else
	{		
		FileData.General = InsertItem(new COptionTreeItem);
		FileData.General->SetLabelText(GetResString(IDS_INFLST_FILE_GENERAL));
		FileData.General->Expand(m_bExpandedFile[0]);
		FileData.FullName = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, FileData.General);
		FileData.FullName->SetLabelText(GetResString(IDS_INFLST_FILE_FULLNAME));
		if(FileData.FullName->CreateStaticItem(0))
			FileData.FullName->SetTextColor(m_crEntryTextColor);
		FileData.MetFile = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, FileData.General);
		FileData.MetFile->SetLabelText(GetResString(IDS_INFLST_FILE_METFILE));
		if(FileData.MetFile->CreateStaticItem(0))
			FileData.MetFile->SetTextColor(m_crEntryTextColor);
		FileData.Hash = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, FileData.General);
		FileData.Hash->SetLabelText(GetResString(IDS_INFLST_FILE_HASH));
		if(FileData.Hash->CreateStaticItem(0))
			FileData.Hash->SetTextColor(m_crEntryTextColor);
		FileData.FileSize = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, FileData.General);
		FileData.FileSize->SetLabelText(GetResString(IDS_INFLST_FILE_FILESIZE));
		if(FileData.FileSize->CreateStaticItem(0))
			FileData.FileSize->SetTextColor(m_crEntryTextColor);
		FileData.PartFileStatus = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, FileData.General);
		FileData.PartFileStatus->SetLabelText(GetResString(IDS_INFLST_FILE_PARTFILESTATUS));
		if(FileData.PartFileStatus->CreateStaticItem(0))
			FileData.PartFileStatus->SetTextColor(m_crEntryTextColor);
		FileData.SourceNames = (COptionTreeItemComboBox*)InsertItem(new COptionTreeItemComboBox(), FileData.General);
		FileData.SourceNames->SetLabelText(GetResString(IDS_INFLST_FILE_SOURCENAMES));
		if(FileData.SourceNames->CreateComboItem(NULL) == TRUE)
		{	
			FileData.SourceNames->SetTextColor(m_crEntryTextColor);
			FileData.SourceNames->SetCurSel(0);
			FileData.bSourceNameCombo = true;
		}
		else
			FileData.bSourceNameCombo = false;
		FileData.iSourceNameUpdateDelay = 0;
			
		FileData.Transfer = InsertItem(new COptionTreeItem);
		FileData.Transfer->SetLabelText(GetResString(IDS_INFLST_FILE_TRANSFER));
		FileData.Transfer->Expand(m_bExpandedFile[1]);
		FileData.FoundSources = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, FileData.Transfer);
		FileData.FoundSources->SetLabelText(GetResString(IDS_INFLST_FILE_FOUNDSOURCES));
		if(FileData.FoundSources->CreateStaticItem(0))
			FileData.FoundSources->SetTextColor(m_crEntryTextColor);
		FileData.Transfering = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, FileData.Transfer);
		FileData.Transfering->SetLabelText(GetResString(IDS_INFLST_FILE_TRANSFERINGSOURCES));
		if(FileData.Transfering->CreateStaticItem(0))
			FileData.Transfering->SetTextColor(m_crEntryTextColor);
		
		FileData.FilepartCount = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, FileData.Transfer);
		FileData.FilepartCount->SetLabelText(GetResString(IDS_INFLST_FILE_FILEPARTCOUNT));
		if(FileData.FilepartCount->CreateStaticItem(0))
			FileData.FilepartCount->SetTextColor(m_crEntryTextColor);
		FileData.PartAvailable = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, FileData.Transfer);
		FileData.PartAvailable->SetLabelText(GetResString(IDS_INFLST_FILE_PARTAVAILABLE));
		if(FileData.PartAvailable->CreateStaticItem(0))
			FileData.PartAvailable->SetTextColor(m_crEntryTextColor);
		FileData.LastSeenComplete = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, FileData.Transfer);
		FileData.LastSeenComplete->SetLabelText(GetResString(IDS_INFLST_FILE_LASTSEENCOMPLETE));
		if(FileData.LastSeenComplete->CreateStaticItem(0))
			FileData.LastSeenComplete->SetTextColor(m_crEntryTextColor);
		FileData.Transfered = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, FileData.Transfer);
		FileData.Transfered->SetLabelText(GetResString(IDS_INFLST_FILE_TRANSFERED));
		if(FileData.Transfered->CreateStaticItem(0))
			FileData.Transfered->SetTextColor(m_crEntryTextColor);
		FileData.CompletedSize = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, FileData.Transfer);
		FileData.CompletedSize->SetLabelText(GetResString(IDS_INFLST_FILE_COMPLETEDSIZE));
		if(FileData.CompletedSize->CreateStaticItem(0))
			FileData.CompletedSize->SetTextColor(m_crEntryTextColor);
		FileData.DataRate = (COptionTreeItemStatic*)InsertItem(new COptionTreeItemStatic, FileData.Transfer);
		FileData.DataRate->SetLabelText(GetResString(IDS_INFLST_FILE_DATARATE));
		if(FileData.DataRate->CreateStaticItem(0))
			FileData.DataRate->SetTextColor(m_crEntryTextColor);
	}

//	SetRedraw(TRUE);
//	Invalidate();

	if(bWasWindowVisible)
		ShowWindow(SW_SHOW);
	
	m_bClear = false;
}

BOOL CInfoListCtrl::Create(DWORD dwStyle, RECT rcRect, CWnd *pParentWnd, UINT nID)
{
	dwStyle |= WS_CLIPCHILDREN;
	return COptionTree::Create(dwStyle, rcRect, pParentWnd, OT_OPTIONS_SHADEEXPANDCOLUMN | OT_OPTIONS_SHADEROOTITEMS, nID);
}

void CInfoListCtrl::UpdateData(bool bRedraw, bool bExpandAllItems)
{
    EMULE_TRY
	if(!IsWindowVisible())
		return;
	
	char buffer[100];
	
	if(m_bUser)
	{
		if(m_client != NULL)
		{
			bool loadSourceName = FALSE;
			if(m_client->GetUserName()) 
				loadSourceName = strstr(m_client->GetUserName(), GetResString(IDS_LOADEDSOURCE));
			
			if(UserData.General->IsExpanded())
			{			
				if(m_client->GetUserName())
					UserData.UserName->SetStaticText(m_client->GetUserName());
				else
					UserData.UserName->SetStaticText("?");
					
				if(m_client->GetUserName())
				{
					buffer[0] = 0;
					for (uint16 i = 0;i != 16;i++)
						sprintf(buffer,"%s%02X",buffer,m_client->GetUserHash()[i]);
					UserData.UserHash->SetStaticText(buffer);
				}
				else
					UserData.UserHash->SetStaticText("?");
				bool isPlus=(m_client->PlusVersion() && m_client->PlusVersion()<0x2600);
				switch(m_client->GetClientSoft())
				{
					case SO_UNKNOWN:
						UserData.ClientSoftware->SetStaticText("?");
						UserData.ClientVersion->SetStaticText("?");
						break;
					case SO_EMULE:
					case SO_LMULE:
					case SO_CDONKEY:
					case SO_OLDEMULE:
					case SO_SHAREAZA:
						if(isPlus)	//Cax2 - second check - don't display the 38e (pre v1?) mods
							UserData.ClientSoftware->SetStaticText("eMule  ("+GetClientNameAndVersionString(m_client)+")");
						else
							UserData.ClientSoftware->SetStaticText("eMule");

						if(m_client->GetMuleVersion())
						{
							if(m_client->GetModVersion() && !isPlus)
								sprintf(buffer,"v0.%02X [%s]",m_client->GetMuleVersion(), m_client->GetModVersion());
							else
								sprintf(buffer,"v0.%02X",m_client->GetMuleVersion());
							UserData.ClientVersion->SetStaticText(buffer);
						}
						else
							UserData.ClientVersion->SetStaticText("?");
						break;

					//Cax2 - hybrid bugfix & simplified the code
					default:
						sprintf(buffer,"%s",GetClientNameString(m_client->GetClientSoft()));
						UserData.ClientSoftware->SetStaticText(buffer);
						sprintf(buffer,"v%s",GetClientVersionString(m_client->GetClientSoft(),m_client->GetVersion()));
						UserData.ClientVersion->SetStaticText(buffer);
				}

				sprintf(buffer,"%u (%s)",m_client->GetUserID(),(m_client->HasLowID() ? "Low":"High"));
				UserData.ID->SetStaticText(buffer);
						
				sprintf(buffer,"%s:%i",m_client->GetFullIP(),m_client->GetUserPort());
				UserData.IPAddress->SetStaticText(buffer);

				if(m_client->GetServerIP())
				{
					in_addr server;
					server.S_un.S_addr = m_client->GetServerIP();
					UserData.ServerIP->SetStaticText(inet_ntoa(server));
									
					CServer* cserver = theApp.serverlist->GetServerByAddress(inet_ntoa(server), m_client->GetServerPort()); 
					if(cserver)
						UserData.ServerName->SetStaticText(cserver->GetListName());
					else
						UserData.ServerName->SetStaticText("?");
				}
				else
				{
					UserData.ServerIP->SetStaticText("?");
					UserData.ServerName->SetStaticText("?");
				}
			}

			if(UserData.Transfer->IsExpanded())
			{
				CKnownFile* file = theApp.sharedfiles->GetFileByID(m_client->reqfileid);
				if(file)
					UserData.CurDownloading->SetStaticText(file->GetFileName());
				else
					UserData.CurDownloading->SetStaticText("-");

				
				UserData.UploadedSession->SetStaticText(CastItoXBytes(m_client->GetTransferedDown()));
				
				
				UserData.DownloadedSession->SetStaticText(CastItoXBytes(m_client->GetTransferedUp()));
				
				sprintf(buffer,"%.1f KB/s",(float)m_client->GetDownloadDatarate()/1024);
				UserData.AverageUploadrate->SetStaticText(buffer);
				
				sprintf(buffer,"%.1f KB/s",(float)m_client->GetDatarate()/1024);
				UserData.AverageDownloadrate->SetStaticText(buffer);
			}

			if(m_client->Credits())
			{
				
				UserData.UploadedTotal->SetStaticText(CastItoXBytes(m_client->Credits()->GetDownloadedTotal()));
				
				
				UserData.DownloadedTotal->SetStaticText(CastItoXBytes(m_client->Credits()->GetUploadedTotal()));
								
				sprintf(buffer,"%.1f",(float)m_client->Credits()->GetScoreRatio());
				UserData.DlUpModifier->SetStaticText(buffer);
			}
			else
			{
				UserData.UploadedTotal->SetStaticText("?");
				UserData.DownloadedTotal->SetStaticText("?");
				UserData.DlUpModifier->SetStaticText("?");
			}

			if(UserData.Scores->IsExpanded())
			{
				char *copy1, *copy2;
				copy1 = _strupr(_strdup(m_client->GetUserName()));
				copy2 = _strupr(_strdup(theApp.glob_prefs->CommunityString()));
 				if(copy1 && copy2)
				{
					bool iscommunity = (strstr(copy1 ,copy2) != NULL );
									
					if(theApp.glob_prefs->CommunityEnabled())
					{
						if(iscommunity) 
							UserData.CommunityUser->SetStaticText(GetResString(IDS_YES));
						else
							UserData.CommunityUser->SetStaticText(GetResString(IDS_NO));
					} 
					else
						UserData.CommunityUser->SetStaticText(GetResString(IDS_DISABLED));
				}
				free(copy1);
				free(copy2);
				
				if(m_client->GetUserName() && !loadSourceName)
				{
					// Bugfix by Maverick
					sprintf(buffer,"%.1f",(float)m_client->GetScore(false,m_client->IsDownloading(),true));
					UserData.Rating->SetStaticText(buffer);
				}
				else
					UserData.Rating->SetStaticText("?");
				
				if(m_client->GetUploadState() != US_NONE)
				{
					sprintf(buffer,"%u",m_client->GetScore(m_client->IsDownloading(),false));
					UserData.UploadQueueScore->SetStaticText(buffer);
				}
				else
					UserData.UploadQueueScore->SetStaticText("-");

				// By Maverick
				sprintf(buffer,"%0.1f",m_client->GetRareFilePushRatio());
				UserData.RFRatio->SetStaticText(buffer);

				sprintf(buffer,"%0.1f",m_client->GetSmallFilePushRatio());
				UserData.SFRatio->SetStaticText(buffer);
				// End Maverick
			}

			// By Maverick
			if(UserData.RemoteScores->IsExpanded())
			{
				if (!m_client->GetRemoteCommunityEnabled())
					UserData.RemoteCommunityUser->SetStaticText(GetResString(IDS_DISABLED));
				else if (m_client->GetRemoteCommunity()) 
					UserData.RemoteCommunityUser->SetStaticText(GetResString(IDS_YES));
				else
					UserData.RemoteCommunityUser->SetStaticText(GetResString(IDS_NO));

				if (m_client->GetRemoteQueueRank())
				{
					sprintf(buffer,"%ld",m_client->GetRemoteQueueRank());
					UserData.RemoteQueueRank->SetStaticText(buffer);
				}
				else UserData.RemoteQueueRank->SetStaticText("??");

				sprintf(buffer,"%0.1f",m_client->GetRemoteBaseModifier());
				UserData.RemoteDlUpModifier->SetStaticText(buffer);

				sprintf(buffer,"%ld",m_client->GetRemoteRatio());
				UserData.RemoteRating->SetStaticText(buffer);

				if (m_client->IsRemoteInfoAvaiable())
				{
					sprintf(buffer,"%ld",m_client->GetRemoteScore());
					UserData.RemoteUploadQueueScore->SetStaticText(buffer);
				} else
				{
					UserData.RemoteUploadQueueScore->SetStaticText("??");
				}

				if (m_client->GetRemoteClientSpeed() == 0)
					UserData.RemoteClientSpeed->SetStaticText("??");
				else {
					sprintf(buffer,"%ld",m_client->GetRemoteClientSpeed());
					UserData.RemoteClientSpeed->SetStaticText("??");
				}
			}
			// By Maverick
		}
	}
	else
	{
		if(m_file != NULL)
		{
			if(FileData.General->IsExpanded())
			{
				FileData.FullName->SetStaticText(m_file->GetFileName());
				FileData.MetFile->SetStaticText(m_file->GetFullName());
				
				buffer[0] = 0;
				for (uint16 i = 0;i != 16;i++) // hmm I wonder if there is a standart function for this
					sprintf(buffer,"%s%02X",buffer,m_file->GetFileHash()[i]);
				FileData.Hash->SetStaticText(buffer);
				
				
				sprintf(buffer,"%s",buffer);
				FileData.FileSize->SetStaticText(CastItoXBytes(m_file->GetFileSize()));
				
				FileData.PartFileStatus->SetStaticText(m_file->GetPartfileStatus());
				if(FileData.iSourceNameUpdateDelay % 10 == 0)
					FillSourcenameList();
				FileData.iSourceNameUpdateDelay++;
			}

			if(FileData.Transfer->IsExpanded())
			{
				sprintf(buffer,"%i",m_file->GetPartCount());
				FileData.FilepartCount->SetStaticText(buffer);

				float percent	=	0.;
				if ( m_file->GetPartCount() )
				{
					percent	=	(float)((m_file->GetAvailablePartCount()*100)/ m_file->GetPartCount());
				}
				sprintf(buffer,"%i (%.1f%%)",m_file->GetAvailablePartCount(),percent);
				FileData.PartAvailable->SetStaticText(buffer);
				
				if(m_file->lastseencomplete == NULL) 
					sprintf(buffer, GetResString(IDS_UNKNOWN).MakeLower()); 
				else
					sprintf(buffer,m_file->localelastseencomplete());

					//sprintf(buffer, m_file->lastseencomplete.Format("%A, %Y-%m-%d, %X"));

				FileData.LastSeenComplete->SetStaticText(buffer);
							
				
				FileData.Transfered->SetStaticText(CastItoXBytes(m_file->GetTransfered()));
				
				
				sprintf(buffer, "%s (%.02f%%)", CastItoXBytes(m_file->GetCompletedSize()), m_file->GetPercentCompleted());
							 
				char buffer2[100] = "";
				float saved; 
				if(m_file->GetStatus() == PS_COMPLETING || m_file->GetStatus() == PS_COMPLETE) 
					saved = (float)m_file->GetTransfered() / (float)m_file->GetFileSize(); 
				else 
				{	
					if(m_file->GetCompletedSize())
						saved = (float)m_file->GetTransfered() / (float)m_file->GetCompletedSize(); 
					else
						saved = 1;
				}
				saved *= 100.0; 
				if(saved < 100.0) 
					sprintf(buffer2,"  Saved: %.02f %%",(float)100.0-saved); 
				if(saved > 100.0) 
					sprintf(buffer2,"  Lost: %.02f %%",(float)saved-100.0); 
			//	if(saved == 100.0) 
			//		sprintf(buffer2,"  Nothing special");
	            
				strcat(buffer,buffer2);
				FileData.CompletedSize->SetStaticText(buffer);

				sprintf(buffer,"%.2f kB/s",(float)m_file->GetDatarate()/1024);
				FileData.DataRate->SetStaticText(buffer);
				
				sprintf(buffer,"%i",m_file->GetSourceCount());
				FileData.FoundSources->SetStaticText(buffer);
				
				sprintf(buffer,"%i",m_file->GetTransferingSrcCount());
				FileData.Transfering->SetStaticText(buffer);
			}
		}
	}

	if(bExpandAllItems)
		ExpandAllItems();
	
	if(bRedraw)
		Invalidate();
    EMULE_CATCH
}

void CInfoListCtrl::OnTimer(UINT nIDEvent)
{
	if(nIDEvent == m_nUpdateTimer)
		UpdateData();
	COptionTree::OnTimer(nIDEvent);
}

void CInfoListCtrl::OnShowWindow(BOOL bShow, UINT nStatus)
{
	COptionTree::OnShowWindow(bShow, nStatus);

	if(bShow)
	{
		//UpdateData();	// bad one :(
		m_nUpdateTimer = SetTimer(1, 500, NULL);
	}
	else
	{
		KillTimer(m_nUpdateTimer);
	}
}

void CInfoListCtrl::Localize()
{
	if(GetSafeHwnd())
	{
		if(m_bUser)
		{
			if(m_client != NULL)
			{	
				ReCreateList(m_bUser);
				UpdateData(true,false);
			}
		}
		else
		{	
			if(m_file != NULL)
			{	
				ReCreateList(m_bUser);
				UpdateData(true,false);
			}
		}
	}
}

void CInfoListCtrl::SwitchToUser(CUpDownClient* client)
{
	if(client == m_client)
		return;
			
	if(client == NULL)
	{				
		SaveState(m_bUser);
		m_client = NULL;
		SetRedraw(FALSE);
		DeleteAllItems();
		SetRedraw(TRUE);
		if(IsWindowEnabled())
		Invalidate();
	
		m_file = NULL;
		m_bUser = true;

		return;
	}
	
	if(m_bClear || !m_bUser || m_client == NULL)
	{
		m_client = client;
		SaveState(m_bUser);
		ReCreateList(true);
            	
		m_file = NULL;
		m_bUser = true;

		UpdateData(FALSE, FALSE);
		return;
	}
	
	m_client = client;
		
	m_file = NULL;
	m_bUser = true;
		
	UpdateData(FALSE, FALSE);
}

void CInfoListCtrl::SwitchToFile(CPartFile* file)
{
	if(file == m_file && file != NULL)
		return;
			
	if(file == NULL)
	{
		SaveState(m_bUser);
		m_file = NULL;
		SetRedraw(FALSE);
		DeleteAllItems();
		SetRedraw(TRUE);
		if(IsWindowEnabled())
		Invalidate();

		m_client = NULL;
		m_bUser = false;

		return;
	}
	
	if(m_bUser || m_file == NULL)
	{
		if(m_file)
		{
			m_file = file;
			SaveState(m_bUser);
		}
		else
			m_file = file;
		ReCreateList(false);

		m_client = NULL;
		m_bUser = false;

		UpdateData(FALSE, FALSE);
		return;
	}
			
	m_file = file;
	m_client = NULL;
	m_bUser = false;
	FileData.iSourceNameUpdateDelay = 0;

	UpdateData(FALSE, FALSE);
}

struct FSL_TempStruct
{
	CString strFileName;
	int iCount;
};

void CInfoListCtrl::FillSourcenameList() 
{
	if(FileData.bSourceNameCombo)
	{
		//FileData.SourceNames->Clear();
		while(FileData.SourceNames->GetCount())
			FileData.SourceNames->DeleteString(0);
				
		if(m_file)
		{
			CList<FSL_TempStruct,FSL_TempStruct&> lstSourceNames;

			POSITION pos1,pos2,pos3; 
			CUpDownClient* cur_src; 

            for (int sl=0;sl<SOURCESSLOTS;sl++) if (!m_file->srclists[sl].IsEmpty())
			{
			
				for(pos1 = m_file->srclists[sl].GetHeadPosition(); (pos2 = pos1) != NULL;) 
				{ 
					m_file->srclists[sl].GetNext(pos1); 
					cur_src = m_file->srclists[sl].GetAt(pos2); 
					if(cur_src->GetClientFilename() != 0) 
					{ 
						CString strFileName;
						strFileName.Format("%s", cur_src->GetClientFilename());
						
						bool bFound = false;
						pos3 = lstSourceNames.GetHeadPosition();
						for(int i = 0; i < lstSourceNames.GetCount(); i++)
						{
							FSL_TempStruct src = lstSourceNames.GetAt(pos3);
							if(strFileName == src.strFileName)
							{	
								src.iCount++;
								bFound = true;
								i = lstSourceNames.GetCount();
								lstSourceNames.SetAt(pos3, src);
							}
							lstSourceNames.GetNext(pos3);
						}
						if(!bFound)
						{
							FSL_TempStruct src;
							src.strFileName = strFileName;
							src.iCount = 1;
							lstSourceNames.AddTail(src);
						}
					}
				}
								
			}

			if(lstSourceNames.GetCount() > 0)
				for(int i = 0; i < lstSourceNames.GetCount(); i++)
				{	
					pos3 = lstSourceNames.GetHeadPosition();
					POSITION posHighest = pos3;
					int iHighest = 0;
					for(int j = 0; j < lstSourceNames.GetCount(); j++)
					{
						FSL_TempStruct srctmp = lstSourceNames.GetAt(pos3);
						if(srctmp.iCount > iHighest)
						{
							iHighest = srctmp.iCount;
							posHighest = pos3;
						}
						lstSourceNames.GetNext(pos3);
					}
					
					FSL_TempStruct src = lstSourceNames.GetAt(posHighest);
					CString strTemp;
					strTemp.Format("%s   (%d)", src.strFileName, src.iCount);
					FileData.SourceNames->AddString(strTemp);
					src.iCount = 0;
					lstSourceNames.SetAt(posHighest, src);
				}
			else
				FileData.SourceNames->AddString(GetResString(IDS_INFLST_FILE_NOSOURCES));

			FileData.SourceNames->SetCurSel(0);
		}
	}
}