//--- xrmb:parttraffic ---
//--- there are so many changes in here, maybe its easier to exchange the whole file ---

//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "stdafx.h"
#include "emule.h"
#include "SharedFilesCtrl.h"
#include "otherfunctions.h"
#include "CommentDialog.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#if JUMPSTART
#define MP_JUMPSTART 14791
#endif

//--- minimum repaint time for a trafficbar (ms) ---
#define SFL_BARUPDATE 1000

//--- it's much easier to use this with other mods ---
enum
{ 
	SFL_COLUMN_FILENAME=0, 
	SFL_COLUMN_FILESIZE, 
	SFL_COLUMN_TYPE, 
	SFL_COLUMN_PRIORITY, 
	SFL_COLUMN_PERMISSION, 
	SFL_COLUMN_FILEID, 
	SFL_COLUMN_REQUESTS, 
	SFL_COLUMN_ACCEPTED, 
	SFL_COLUMN_TRANSFERED, 
	SFL_COLUMN_PARTTRAFFIC, 
	SFL_COLUMN_UPLOADS, 
	SFL_COLUMN_COMPLETESRC,
};

#define sortcmp(a, b) ((a)==(b))?0: (((a)<(b))?-1:1)

#define GrayIt(gray, color) gray?(0x444444+0x010101*((GetRValue(color)*30+GetGValue(color)*59+GetBValue(color)*11)/0xFF)):color

IMPLEMENT_DYNAMIC(CSharedFilesCtrl, CMuleListCtrl)

BEGIN_MESSAGE_MAP(CSharedFilesCtrl, CMuleListCtrl)
	ON_WM_CONTEXTMENU()
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnClick)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDoubleClick)
END_MESSAGE_MAP()

//--- static members ---
uint8	CSharedFilesCtrl::m_p2p[6];
bool	CSharedFilesCtrl::m_sortParts=false;

CSharedFilesCtrl::CSharedFilesCtrl() : m_pSCM(NULL)
{
	EMULE_TRY

	m_statusWidth=-1;

	SetColoring(0);
	SetDisplay(0, false);

	//--- xrmb:allyaknow ---
	m_allYaKnow=false;
	//--- :xrmb ---
	
	//--- i wrote my own little sort helper ---
	m_listSorter.init(12);

	m_listSorter.item(SFL_COLUMN_FILESIZE)->set(1, true);
	m_listSorter.item(SFL_COLUMN_PRIORITY)->set(1, true);
	m_listSorter.item(SFL_COLUMN_REQUESTS)->set(2, true);
	m_listSorter.item(SFL_COLUMN_ACCEPTED)->set(2, true);
	m_listSorter.item(SFL_COLUMN_TRANSFERED)->set(2, true);
	m_listSorter.item(SFL_COLUMN_PARTTRAFFIC)->set(2, true);
	m_listSorter.item(SFL_COLUMN_UPLOADS)->set(2, true);
	m_listSorter.item(SFL_COLUMN_COMPLETESRC)->set(1,true);

	//--- fast prio 2 prio converter, need because the prios are messed up a little bit ---
	m_p2p[PR_VERYLOW]	= 0;
	m_p2p[PR_LOW]		= 1;
	m_p2p[PR_NORMAL]	= 2;
	m_p2p[PR_HIGH]		= 3;
	m_p2p[PR_VERYHIGH]	= 4;
	m_p2p[PR_AUTO]		= 5;

	EMULE_CATCH
}

CSharedFilesCtrl::~CSharedFilesCtrl()
{
	if(m_pSCM)
		delete m_pSCM;
}

void CSharedFilesCtrl::Init()
{
	EMULE_TRY

	SetColoring(theApp.glob_prefs->GetUpbarColor());
	SetDisplay(theApp.glob_prefs->GetUpbarStyle(), false);

	//--- that seems to be the way to make taller item :) (i hate mfc... honestly i don't understand mfc :) ---
	CImageList ilDummyImageList;
	ilDummyImageList.Create(1, 17, ILC_COLOR, 1, 1); 
	SetImageList(&ilDummyImageList, LVSIL_SMALL);

	SetExtendedStyle(LVS_EX_FULLROWSELECT);
	ModifyStyle(LVS_SINGLESEL,0);

	//--- in the official emule source the is a unlogical value at the end (for me :) ---
	InsertColumn(SFL_COLUMN_FILENAME, GetResString(IDS_DL_FILENAME), LVCFMT_LEFT, 250);
	InsertColumn(SFL_COLUMN_FILESIZE, GetResString(IDS_DL_SIZE), LVCFMT_LEFT, 100);
	InsertColumn(SFL_COLUMN_TYPE, GetResString(IDS_TYPE), LVCFMT_LEFT, 50);
	InsertColumn(SFL_COLUMN_PRIORITY, GetResString(IDS_PRIORITY), LVCFMT_LEFT, 70);
	InsertColumn(SFL_COLUMN_PERMISSION, GetResString(IDS_PERMISSION), LVCFMT_LEFT, 100);
	InsertColumn(SFL_COLUMN_FILEID,	GetResString(IDS_FILEID), LVCFMT_LEFT, 220);
	InsertColumn(SFL_COLUMN_REQUESTS, GetResString(IDS_SF_REQUESTS), LVCFMT_LEFT, 100);
	InsertColumn(SFL_COLUMN_ACCEPTED, GetResString(IDS_SF_ACCEPTS),	LVCFMT_LEFT, 100);
	InsertColumn(SFL_COLUMN_TRANSFERED, GetResString(IDS_SF_TRANSFERRED), LVCFMT_LEFT, 120);
	InsertColumn(SFL_COLUMN_COMPLETESRC, GetResString(IDS_SF_COMPLETESRC), LVCFMT_LEFT, 100);

	//--- these are my columns ---
	InsertColumn(SFL_COLUMN_PARTTRAFFIC,GetResString(IDS_SF_PARTTRAFFIC),LVCFMT_LEFT, 120);
	InsertColumn(SFL_COLUMN_UPLOADS,GetResString(IDS_SF_COLUPLOADS),LVCFMT_LEFT, 120);

	LoadSettings(CPreferences::tableShared);

	// Cax2
	if (theApp.glob_prefs->DoUseSort())
		SortInit(theApp.glob_prefs->GetFileSortCol());
	else
		SortInit(0);

	EMULE_CATCH
}

void CSharedFilesCtrl::SortInit(int sortCode) // Cax2 sortdlg
{ 
	EMULE_TRY

	int m_CurrentSortItem=(sortCode>10000)?sortCode-10000:sortCode;
	bool reverse=(m_CurrentSortItem>=100);
	m_CurrentSortItem-=reverse?100:0;
	if (sortCode>10000)
		SetSortArrow(m_CurrentSortItem,(sortCode<10100)?arrowDoubleUp:arrowDoubleDown);
	else
		SetSortArrow(m_CurrentSortItem,(sortCode<100));
	m_listSorter.clicked(m_CurrentSortItem);	//Cax2 what a palaver!
	m_listSorter.item(m_CurrentSortItem)->sortIt((sortCode>10000)?2:1,!reverse);	//Cax2 what a palaver!
	//AddLogLine(true, "sort column %i, direction %s, level %i reverse is: %i", m_listSorter.selected(), m_listSorter.dir()?"ascending":"descending", m_listSorter.level(),reverse);
	SortItems(&SortProc, (LPARAM)&m_listSorter);	//Cax2 what a palaver!

	EMULE_CATCH
}

void CSharedFilesCtrl::Localize() 
{
	EMULE_TRY

	if(GetSafeHwnd())
	{
		CHeaderCtrl* pHeaderCtrl = GetHeaderCtrl();
		HDITEM hdi;
		hdi.mask = HDI_TEXT;
		CString strRes;

		strRes = GetResString(IDS_DL_FILENAME);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_FILENAME, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DL_SIZE);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_FILESIZE, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_TYPE);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_TYPE, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_PRIORITY);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_PRIORITY, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_PERMISSION);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_PERMISSION, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_FILEID);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_FILEID, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_SF_REQUESTS);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_REQUESTS, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_SF_ACCEPTS);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_ACCEPTED, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_SF_TRANSFERRED);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_TRANSFERED, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_SF_COMPLETESRC);	//netwolf: zegzav complete sources
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_COMPLETESRC, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_SF_PARTTRAFFIC);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_PARTTRAFFIC, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_SF_COLUPLOADS);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_UPLOADS, &hdi);
		strRes.ReleaseBuffer();
	}

	EMULE_CATCH
}

void CSharedFilesCtrl::ShowFileList(CSharedFileList* in_sflist)
{
	EMULE_TRY

	SetRedraw(false);

	DeleteAllItems();
	CCKey bufKey;
	CKnownFile* cur_file;
	for(POSITION pos = in_sflist->m_Files_map.GetStartPosition();pos != 0;)
	{
		in_sflist->m_Files_map.GetNextAssoc(pos, bufKey, cur_file);
		ShowFile(cur_file, false);
	}	
	ShowFilesCount();

	SetRedraw(true);

	//--- xrmb:allyaknow ---
	m_allYaKnow=false;
	//--- :xrmb ---

	EMULE_CATCH
}

//--- xrmb:allyaknow ---
void CSharedFilesCtrl::ShowKnownList()
{
	EMULE_TRY

	CKnownFileList* list=theApp.knownfiles;

	SetRedraw(false);

	DeleteAllItems();

	uint32 records=list->GetCount();
	for(uint32 i=0; i<records; i++) 
	{
		ShowFile(list->ElementAt(i), false);
	}

	SetRedraw(true);

	m_allYaKnow=true;

	EMULE_CATCH
}
//--- :xrmb ---

void CSharedFilesCtrl::UpdateFile(CKnownFile* file, uint32 itemnr, bool resort)
{
	EMULE_TRY

	if(file == NULL)
		return;

	//--- like everywhere else i replace the columnumbers ---
	char buffer[250];

	
	SetItemText(itemnr,SFL_COLUMN_FILESIZE,CastItoXBytes(file->GetFileSize()));
	SetItemText(itemnr,SFL_COLUMN_TYPE,GetFiletypeByName(file->GetFileName()));

	// Modified by Tarod for UAP
	if (file->IsAutoPrioritized())
	{
		if (file->GetPriority() == PR_NORMAL)
			SetItemText(itemnr,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOAUTONORMAL));
		else if (file->GetPriority() == PR_HIGH)
			SetItemText(itemnr,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOAUTOHIGH));
		else if (file->GetPriority() == PR_VERYHIGH)
			SetItemText(itemnr,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOAUTORELEASE));
	} else {
		if (file->GetPriority() == PR_VERYLOW)
			SetItemText(itemnr,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOVERYLOW));
		else if (file->GetPriority() == PR_LOW)
			SetItemText(itemnr,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOLOW));
		else if (file->GetPriority() == PR_NORMAL)
			SetItemText(itemnr,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIONORMAL));
		else if (file->GetPriority() == PR_HIGH)
			SetItemText(itemnr,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOHIGH));
		else if (file->GetPriority() == PR_VERYHIGH)
			SetItemText(itemnr,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIORELEASE));
	}

	/*if (file->GetPermissions() == PERM_NOONE)
		SetItemText(itemnr,SFL_COLUMN_PERMISSION,"Hidden");
	else if (file->GetPermissions() == PERM_FRIENDS)
		SetItemText(itemnr,SFL_COLUMN_PERMISSION,"Friends Only");
	else
		SetItemText(itemnr,SFL_COLUMN_PERMISSION,"Public Shared");*/
	SetItemText(itemnr,SFL_COLUMN_PERMISSION,GetResString(IDS_FSTATUS_PUBLIC));

	buffer[0] = 0;
	for (uint16 i = 0;i != 16;i++) // hmm I wonder if there is a standard function for this
		sprintf(buffer,"%s%02X",buffer,file->GetFileHash()[i]);
	SetItemText(itemnr,SFL_COLUMN_FILEID,buffer);

	uint64 a=file->statistic.GetRequests();			//katsyonak - 4GB bugfix
	uint64 b=file->statistic.GetAllTimeRequests();
	if(a || b)
		sprintf(buffer, "%I64u (%I64u)", a, b);	//Cax2 - display bugfix
	else
		buffer[0]=0;
	SetItemText(itemnr, SFL_COLUMN_REQUESTS, buffer);

	a=file->statistic.GetAccepts();
	b=file->statistic.GetAllTimeAccepts();
	if(a || b)
		sprintf(buffer, "%I64u (%I64u)", a, b);	//Cax2 - display bugfix
	else
		buffer[0]=0;
	SetItemText(itemnr, SFL_COLUMN_ACCEPTED, buffer);
	
	a=file->statistic.GetTransfered();
	b=file->statistic.GetAllTimeTransfered();
	if(a || b)
	{
		sprintf(buffer, "%s (%s)", CastItoXBytes(a), CastItoXBytes(b));
	}
	else
		buffer[0]=0;
	SetItemText(itemnr, SFL_COLUMN_TRANSFERED, buffer);

	//--- upload column text, or no text if 0 ---
	a=file->GetFileSize();
	b=file->statistic.GetAllTimeTransfered();
	double	cr=file->statistic.GetCompleteReleases();
	if(a && cr+b!=0.0 )
		sprintf(buffer, "%0.2f (%0.2f)", cr, (double)b/a);
	else
		buffer[0]=0;
	SetItemText(itemnr,SFL_COLUMN_UPLOADS,buffer);

	//--- kids/parts open? ---
	sfl_itemdata* itemdataParent=(sfl_itemdata*)GetItemData(itemnr);
	if(itemdataParent->isOpen)
	{
		//--- update all parts ---
		for(uint16 part=0; part<itemdataParent->parts; part++)
		{
			sfl_itemdata* itemdata=(sfl_itemdata*)GetItemData(itemnr+1+part);

			//--- xrmb:partprio ---
			switch(file->GetPartStatus(itemdata->part)) 
			{
			case PR_PART_ON:
				SetItemText(itemnr+1+part, SFL_COLUMN_PRIORITY, "");
				break;
			
			case PR_PART_HIDDEN:
				SetItemText(itemnr+1+part, SFL_COLUMN_PRIORITY, GetResString(IDS_HIDDEN));
				break;

			case PR_PART_OFF:
				SetItemText(itemnr+1+part, SFL_COLUMN_PRIORITY, GetResString(IDS_SF_BLOCKED));
				break;
			}

			/*
			switch(file->GetPartPriority(itemdata->part)) 
			{
			case PR_VERYLOW:
				SetItemText(itemnr+1+part, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIOVERYLOW));
				break;

			case PR_LOW:
				SetItemText(itemnr+1+part, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIOLOW));
				break;

			case PR_NORMAL:
				SetItemText(itemnr+1+part, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIONORMAL));
				break;

			case PR_HIGH:
				SetItemText(itemnr+1+part, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIOHIGH));
				break;

			case PR_VERYHIGH:
				SetItemText(itemnr+1+part, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIORELEASE));
				break;
			}
			*/
			//--- :xrmb ---

			//--- column accepted ---
			uint32	as=file->statistic.GetPartAccepted(itemdata->part, true);
			uint32	a=file->statistic.GetPartAccepted(itemdata->part, false);
			if(as || a)
				sprintf(buffer, "%i (%i)", as, a);
			else
				buffer[0]='\0';
			SetItemText(itemnr+1+part, SFL_COLUMN_ACCEPTED, buffer);

			//--- column transfered ---
			uint32 ts=file->GetPartTraffic(itemdata->part, true);
			uint32 t=file->GetPartTraffic(itemdata->part);
			if(ts || t)
			{
				sprintf(buffer, "%s (%s)", CastItoXBytes(ts), CastItoXBytes(t));
			}
			else
				buffer[0]='\0';
			SetItemText(itemnr+1+part, SFL_COLUMN_TRANSFERED, buffer);

			//--- column complete releases ---
			double	cr=file->statistic.GetCompletePartReleases(itemdata->part);
			if(ts || cr!=0.0)
				sprintf(buffer, "%0.2f (%0.2f)", cr, (double)t/file->GetPartSize(itemdata->part));
			else
				buffer[0]=0;
			SetItemText(itemnr+1+part, SFL_COLUMN_UPLOADS, buffer);

			//--- redraw bar ---
			//itemdata->repaintBar=true;
		}
	}

	// netwolf: completesrc (zegzav) - BEGIN
	buffer[0] = 0;
	uint16 c= file->GetCompleteSourcesCount();
	if (c)
	{
		uint8 n= file->GetCompleteSourcesAccuracy();
		if (n > 0)
		{
			CString strAccuracy('*', n);
			sprintf(buffer, "%u (%s)", c, (const char *)strAccuracy);
		}
		else
		{
			sprintf(buffer, "%u", file->GetCompleteSourcesCount());
		}
	}
	SetItemText(itemnr,SFL_COLUMN_COMPLETESRC,buffer);
	// netwolf: completesrc (zegzav) - END

	//--- redraw the bar ---
	//itemdataParent->repaintBar=true;

	//--- good time for a resort ---
	if(resort)
		SortItems(&SortProc, (LPARAM)&m_listSorter);

	EMULE_CATCH
}

void CSharedFilesCtrl::ShowFile(CKnownFile* file, bool resort)
{
	ShowFile(file, GetItemCount(), resort);
}

void CSharedFilesCtrl::ShowFile(CKnownFile* file, uint32 itemnr, bool resort)
{
	EMULE_TRY

	if(file == NULL)
		return;

	sfl_itemdata	*itemdata=new sfl_itemdata;
	
	itemdata->isFile=true;
	itemdata->isOpen=false;
	itemdata->knownFile=file;
	itemdata->part=0;
	itemdata->parts=0;
	
	itemnr=InsertItem(LVIF_TEXT|LVIF_PARAM, itemnr, file->GetFileName(), 0, 0, 0, (LPARAM)itemdata);
	UpdateFile(file, itemnr, resort);
	ShowFilesCount();

	EMULE_CATCH
}

void CSharedFilesCtrl::RemoveFile(CKnownFile *toRemove) 
{
	EMULE_TRY

	if(toRemove == NULL)
		return;

	sfl_itemdata*	itemdata;
	for(int nItem=0; nItem<GetItemCount(); nItem++)
	{
		itemdata=(sfl_itemdata*)GetItemData(nItem);
		if(itemdata->isFile && itemdata->knownFile==toRemove)
		{
			//--- delete all part-childs ---
			if(itemdata->isOpen)
			{
				for(uint16 part=0; part<itemdata->parts; part++)
				{
					sfl_itemdata* itemdataPart=(sfl_itemdata*)GetItemData(nItem+1);
					if (itemdataPart->isFile) break;	//Cax2 14/01/03	bugfix
					SetItemData(nItem+1, NULL);
					DeleteItem(nItem+1);
					if(itemdataPart) delete itemdataPart;
				}
			}

			SetItemData(nItem, NULL);
			DeleteItem(nItem);
			if(itemdata) delete itemdata;
		}
	}
	ShowFilesCount();

	EMULE_CATCH
}

BOOL CSharedFilesCtrl::DeleteAllItems()
{
	EMULE_TRY

	sfl_itemdata *itemdata;
	for(int i=GetItemCount(); i>0; i--)
	{
		itemdata=(sfl_itemdata *)GetItemData(i-1);
		SetItemData(i-1, NULL);
		//DeleteItem(i-1);
		if(itemdata) delete itemdata;
	}
	return CListCtrl::DeleteAllItems();
	//return true;

	EMULE_CATCH

	return false;
}

void CSharedFilesCtrl::OnContextMenu(CWnd* pWnd, CPoint point)
{
	EMULE_TRY
	
	if(m_pSCM)
	{
		delete m_pSCM;
		m_pSCM=NULL;
	}

	int iSel = GetSelectionMark();
	if (iSel == -1) 
		return;

	sfl_itemdata *itemdata=(sfl_itemdata *)GetItemData(iSel);

	bool justOne=(GetSelectedCount()==1); //Cax2 faster code
	bool None=(GetSelectedCount()==0);

	CTitleMenu	   	m_SharedFilesMenu;
	CMenu		   	m_PrioMenu;
	CMenu		   	m_PermMenu;
	CMenu			m_ed2kMenu;
	CMenu			scm;

	m_SharedFilesMenu.CreatePopupMenu();
	//--- xrmb:allyaknow ---
	if(m_allYaKnow)
		m_SharedFilesMenu.AddMenuTitle(GetResString(IDS_KNOWNFILES));
	else
	//--- :xrmb ---
		m_SharedFilesMenu.AddMenuTitle(GetResString(IDS_SHAREDFILES));
	
	// add priority switcher
	//--- xrmb:allyaknow ---
	if(m_allYaKnow==false)
	{
	//--- :xrmb ---
		if(itemdata->isFile)
		{
			m_PrioMenu.CreateMenu();
			m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOVERYLOW,GetResString(IDS_PRIOVERYLOW));
			m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOLOW,GetResString(IDS_PRIOLOW));
			m_PrioMenu.AppendMenu(MF_STRING,MP_PRIONORMAL,GetResString(IDS_PRIONORMAL));
			m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOHIGH, GetResString(IDS_PRIOHIGH));
			m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOVERYHIGH, GetResString(IDS_PRIORELEASE));
			m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOAUTO, GetResString(IDS_PRIOAUTO));
#if JUMPSTART
			if(!itemdata->knownFile->IsPartFile()) {
                m_PrioMenu.AppendMenu(MF_STRING|MF_SEPARATOR);
				m_PrioMenu.AppendMenu(MF_STRING,MP_JUMPSTART, "Jumpstart");
				m_PrioMenu.CheckMenuItem(MP_JUMPSTART,itemdata->knownFile->GetJumpstartEnabled()?MF_CHECKED:MF_UNCHECKED);
			}
#endif
			m_SharedFilesMenu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_PrioMenu.m_hMenu, GetResString(IDS_PRIORITY));
		}
		else
		{
			m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_PARTON, GetResString(IDS_SF_PARTON));
			m_SharedFilesMenu.EnableMenuItem(MP_SFL_PARTON,itemdata->knownFile->IsPartFile() ? MF_GRAYED:MF_ENABLED);
			m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_PARTHIDDEN, GetResString(IDS_SF_PARTHIDDEN));
			m_SharedFilesMenu.EnableMenuItem(MP_SFL_PARTHIDDEN,itemdata->knownFile->IsPartFile() ? MF_GRAYED:MF_ENABLED);
			m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_PARTOFF, GetResString(IDS_SF_PARTOFF));
			m_SharedFilesMenu.EnableMenuItem(MP_SFL_PARTOFF,itemdata->knownFile->IsPartFile() ? MF_GRAYED:MF_ENABLED);
		}

		if(itemdata->isFile)
		{
			// add permission switcher
			m_PermMenu.CreateMenu();
			m_PermMenu.AppendMenu(MF_STRING,MP_PERMNONE,	GetResString(IDS_FSTATUS_LOCKED));
			m_PermMenu.AppendMenu(MF_STRING,MP_PERMFRIENDS,	GetResString(IDS_FSTATUS_FRIENDSONLY));
			m_PermMenu.AppendMenu(MF_STRING,MP_PERMALL,		GetResString(IDS_FSTATUS_PUBLIC));

			// todo enable when it works
			//m_SharedFilesMenu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_PermMenu.m_hMenu, (LPCTSTR)"Permissions");
			m_SharedFilesMenu.EnableMenuItem((UINT_PTR)m_PrioMenu.m_hMenu,None ? MF_GRAYED:MF_ENABLED);
			m_SharedFilesMenu.AppendMenu(MF_STRING|MF_SEPARATOR);
			if(justOne && !itemdata->knownFile->IsPartFile())
			{
				char* buffer = new char[MAX_PATH];
				strcpy(buffer, itemdata->knownFile->GetPath());
				if (buffer[strlen(buffer)-1]=='\\')
					strcat(buffer,itemdata->knownFile->GetFileName());
				else
					sprintf(buffer,"%s\\%s",buffer,itemdata->knownFile->GetFileName());
				m_pSCM = new CShellContextMenu(m_hWnd,buffer);
				delete buffer;
				scm.CreateMenu();
				m_pSCM->SetMenu(&scm);
				m_SharedFilesMenu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)scm.m_hMenu, GetResString(IDS_SHELLCONTEXT));
			}
			else
				m_SharedFilesMenu.AppendMenu(MF_STRING|MF_GRAYED,NULL, GetResString(IDS_SHELLCONTEXT));
			m_SharedFilesMenu.AppendMenu(MF_STRING,MP_OPENFOLDER, GetResString(IDS_OPENFOLDER));
			m_SharedFilesMenu.EnableMenuItem(MP_OPENFOLDER,((itemdata->knownFile->IsPartFile() || !(justOne)) ? MF_GRAYED:MF_ENABLED));
			m_SharedFilesMenu.AppendMenu(MF_STRING,MP_CMT, GetResString(IDS_CMT_ADD));
			m_SharedFilesMenu.EnableMenuItem(MP_CMT,(justOne) ? MF_ENABLED:MF_GRAYED);
		}

		//This menu option is is for testing..
		//m_SharedFilesMenu.AppendMenu(MF_STRING,Irc_SetSendLink,GetResString(IDS_IRC_ADDLINKTOIRC)); 
		
		m_SharedFilesMenu.AppendMenu(MF_STRING|MF_SEPARATOR); 

		//--- context menu for a shared file ---
		if(itemdata->isFile)
		{
			if(justOne)
				m_PrioMenu.EnableMenuItem(MP_PRIOAUTO,((theApp.glob_prefs->IsUAPEnabled()) && (itemdata->knownFile->IsPartFile())) ? MF_ENABLED:MF_GRAYED);
			else
				m_PrioMenu.EnableMenuItem(MP_PRIOAUTO,theApp.glob_prefs->IsUAPEnabled() ? MF_ENABLED:MF_GRAYED);
		}

		//--- context menu for a part of a file ---
		else
		{
			//--- feel free to add something ---
		}

	//--- xrmb:allyaknow ---
	}
	//--- :xrmb ---

	m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_CLEARALLSTATS, GetResString(IDS_SF_RESETALLSTATS));
	m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_CLEARSTATS, GetResString(IDS_SF_RESETSESSTATS));

	//--- xrmb:allyaknow ---
	m_SharedFilesMenu.AppendMenu(MF_STRING|MF_SEPARATOR); 
	if(m_allYaKnow)
	{
		m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_DELKNOWN, GetResString(IDS_SF_DELETE));
		m_SharedFilesMenu.AppendMenu(MF_STRING|MF_SEPARATOR); 
		m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_MERGEKNOWN, GetResString(IDS_SF_MERGE));
		m_SharedFilesMenu.AppendMenu(MF_STRING|MF_SEPARATOR); 
		m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_ALLYAKNOW, GetResString(IDS_SF_SHOWALLSF));
	}
	else
		m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_ALLYAKNOW, GetResString(IDS_SF_SHOWALLKF));
	//--- :xrmb ---

	m_SharedFilesMenu.AppendMenu(MF_STRING|MF_SEPARATOR); 

//	if(m_allYaKnow==false)
//	{
//		if(itemdata->isFile)
//		{
			m_ed2kMenu.CreateMenu();
			m_ed2kMenu.AppendMenu(MF_STRING,MP_GETED2KLINK, GetResString(IDS_DL_LINK1));
			m_ed2kMenu.AppendMenu(MF_STRING,MP_GETHTMLED2KLINK, GetResString(IDS_DL_LINK2));
			m_ed2kMenu.AppendMenu(MF_STRING,MP_GETSOURCEED2KLINK, GetResString(IDS_CREATESOURCELINK)); //<<-- enkeyDEV(Ottavio84) -Create source ed2k from downloads-
			m_SharedFilesMenu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_ed2kMenu.m_hMenu, GetResString(IDS_ED2KLINKFIX));
			m_SharedFilesMenu.EnableMenuItem((UINT_PTR)m_ed2kMenu.m_hMenu,None ? MF_GRAYED:MF_ENABLED);
//		}
//	}

	int counter;
	CMenu m_Web;
	m_Web.CreateMenu();
	UpdateURLMenu(m_Web,counter);
	UINT flag2;
	flag2=(counter==0) ? MF_GRAYED:MF_STRING;
	m_SharedFilesMenu.AppendMenu(flag2|MF_POPUP,(UINT_PTR)m_Web.m_hMenu, GetResString(IDS_WEBSERVICES));
	m_SharedFilesMenu.EnableMenuItem((UINT_PTR)m_Web.m_hMenu,justOne ? MF_ENABLED:MF_GRAYED);

	m_SharedFilesMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON,point.x,point.y,this);
//	m_SharedFilesMenu.RemoveMenu(18,MF_BYPOSITION);
	m_Web.DestroyMenu();
	m_SharedFilesMenu.DestroyMenu();

	if(m_pSCM)
		m_pSCM->CleanUp();

	EMULE_CATCH
}

BOOL CSharedFilesCtrl::OnCommand(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	int iSel = GetSelectionMark();
	if (iSel == -1)
		return false;

	sfl_itemdata* itemdata=(sfl_itemdata*)GetItemData(iSel);
	CKnownFile* file=itemdata->knownFile;
		if (wParam>=MP_WEBURL && wParam<=MP_WEBURL+256) {
			RunURL(file, theApp.webservices.GetAt(wParam-MP_WEBURL) );
		}

	// for multiple selections 
	UINT selectedCount = GetSelectedCount(); 
	CArray<CKnownFile*,CKnownFile*> selectedList;
	POSITION pos=GetFirstSelectedItemPosition();
	while(pos)
	{
		int iSel=GetNextSelectedItem(pos);
		itemdata=(sfl_itemdata*)GetItemData(iSel);

		//--- file selection? ---
		if(itemdata->isFile)
		{
			selectedList.Add(itemdata->knownFile);
		}
	}

	switch (wParam)
	{
		case Irc_SetSendLink:
				if(selectedCount > 1) break;
				theApp.emuledlg->ircwnd.SetSendFileString(theApp.CreateED2kLink(file));
				break;
		
		case MP_GETED2KLINK:
				{
					CString str;
					while(selectedList.GetCount())
					{
						str += theApp.CreateED2kLink(selectedList.ElementAt(0));
						selectedList.RemoveAt(0);
						if(!selectedList.IsEmpty())
							str += "\n";
					}
					theApp.CopyTextToClipboard(str);
					break;
				}

		case MP_GETHTMLED2KLINK:
				{
					CString str;
					while(selectedList.GetCount())
					{
						str += theApp.CreateHTMLED2kLink(selectedList.ElementAt(0));
						selectedList.RemoveAt(0);
						if(!selectedList.IsEmpty())
							str += "\n";
					}
				    theApp.CopyTextToClipboard(str);
					break;
				}

		case MP_GETSOURCEED2KLINK:
				{
					if (theApp.serverconnect->IsConnected() || !theApp.serverconnect->IsLowID())
					{
						CString str;
						while(selectedList.GetCount())
						{
							str += theApp.CreateED2kSourceLink(selectedList.ElementAt(0));
							selectedList.RemoveAt(0);
							if(!selectedList.IsEmpty())
								str += "\n";
						}
					    theApp.CopyTextToClipboard(str);
					}
					else
						AfxMessageBox(GetResString(IDS_SOURCELINKFAILED));
				}
				break;
		case MP_OPEN:
			{
				if(selectedCount > 1) break;
				char* buffer = new char[MAX_PATH];
				sprintf(buffer,"%s\\%s",file->GetPath(),file->GetFileName());
				AddLogLine( false, "%s\\%s",file->GetPath(),file->GetFileName());
				ShellOpenFile(buffer);
				delete buffer;
			}
			break; 

		case MP_OPENFOLDER:
			{
				if(selectedCount > 1) break;
				ShellOpenFile(file->GetPath());
			}
			break;

		case MP_CMT: 
			{ 
				if(selectedCount > 1) break;
				CCommentDialog dialog(file); 
				dialog.DoModal(); 
   			} 
			break; 

		//--- xrmb:allyaknow ---
		case MP_SFL_ALLYAKNOW:
			if(m_allYaKnow)
				ShowFileList(theApp.sharedfiles);
			else
				ShowKnownList();
			break;

		case MP_SFL_MERGEKNOWN:
			DeleteAllItems();
			theApp.knownfiles->merge();
			ShowKnownList();
			break;

		case MP_SFL_DELKNOWN:
			{
				//--- TODO: ask if really delete ---
				while(selectedList.GetCount())
				{
					RemoveFile(selectedList.ElementAt(0));
					theApp.knownfiles->RemoveFile(selectedList.ElementAt(0));
					selectedList.RemoveAt(0);
				}
			}
			break;
		//--- :xrmb ---

		case MP_SFL_CLEARSTATS:
		case MP_SFL_CLEARALLSTATS:
			{
				//--- TODO: ask if really erase ---

				bool		all=(wParam==MP_SFL_CLEARALLSTATS);
				CKnownFile	*lastfile=NULL;

				POSITION	pos=GetFirstSelectedItemPosition();
				while(pos)
				{
					int iSel=GetNextSelectedItem(pos);

					itemdata=(sfl_itemdata*)GetItemData(iSel);
					file=itemdata->knownFile;

					//--- file selection? ---
					if(itemdata->isFile)
						itemdata->knownFile->statistic.resetStats(all);

					//--- part selection ---
					else
						itemdata->knownFile->statistic.resetPartTraffic(itemdata->part, all);

					if(file!=lastfile)
					{
						if(lastfile)
							UpdateItem(lastfile, false);
						lastfile=file;
					}
				}

				if(lastfile)
					UpdateItem(lastfile, true);
				RedrawItems(0, GetItemCount());
			}
			break;

		case MP_PRIOVERYLOW:
		case MP_PRIOLOW:
		case MP_PRIONORMAL:
		case MP_PRIOHIGH:
		case MP_PRIOVERYHIGH:
		case MP_PRIOAUTO:
			{
				POSITION pos = GetFirstSelectedItemPosition();
				while(pos != NULL)
				{ 
					int iSel=this->GetNextSelectedItem(pos);

					itemdata=(sfl_itemdata*)GetItemData(iSel);
					file=itemdata->knownFile;

					//--- is there a part in selection? ---
					if(itemdata->isFile)
					{
						file->SetAutoPriority(false);

						switch (wParam) 
						{
							case MP_PRIOVERYLOW:
								file->SetPriority(PR_VERYLOW);
								SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOVERYLOW));
								break;

							case MP_PRIOLOW:
								file->SetPriority(PR_LOW);
								SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOLOW));
								break;

							case MP_PRIONORMAL:
								file->SetPriority(PR_NORMAL);
								SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIONORMAL));
								break;	

							case MP_PRIOHIGH:
								file->SetPriority(PR_HIGH);
								SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOHIGH));
								break;

							case MP_PRIOVERYHIGH:
								file->SetPriority(PR_VERYHIGH);
								SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIORELEASE));
								break;

							case MP_PRIOAUTO:
								if (file->IsPartFile())
								{
									file->SetAutoPriority(true);
									file->UpdateUploadAutoPriority(); 
									switch(file->GetPriority())
									{
										case PR_VERYHIGH:
											SetItemText(iSel, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIOAUTORELEASE));
											break;

										case PR_HIGH:
											SetItemText(iSel, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIOAUTOHIGH));
											break;
							
										case PR_NORMAL:
											SetItemText(iSel, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIOAUTONORMAL));
											break;
									}
								}
								break;
						}

					}
					//--- xrmb:partprio ---
					/*
					else
					{
						switch(wParam)
						{
						case MP_PRIOVERYLOW:
							file->SetPartPriority(itemdata->part, PR_VERYLOW);
							SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOVERYLOW));
							break;

						case MP_PRIOLOW:
							file->SetPartPriority(itemdata->part, PR_LOW);
							SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOLOW));
							break;

						case MP_PRIONORMAL:
							file->SetPartPriority(itemdata->part, PR_NORMAL);
							SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIONORMAL));
							break;	

						case MP_PRIOHIGH:
							file->SetPartPriority(itemdata->part, PR_HIGH);
							SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOHIGH));
							break;

						case MP_PRIOVERYHIGH:
							file->SetPartPriority(itemdata->part, PR_VERYHIGH);
							SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIORELEASE));
							break;
						}
					}
				*/
		//--- :xrmb ---
				}
			}	
			break;
	
		//--- xrmb:partprio ---
		case MP_SFL_PARTON:
		case MP_SFL_PARTOFF:
		case MP_SFL_PARTHIDDEN:
			{
				uint8	setTo;
				switch(wParam)
				{
					case MP_SFL_PARTON:
						setTo=PR_PART_ON;
						break;

					case MP_SFL_PARTOFF:
						setTo=PR_PART_OFF;
						break;

					case MP_SFL_PARTHIDDEN:
						setTo=PR_PART_HIDDEN;
						break;

				}

				POSITION pos=GetFirstSelectedItemPosition();
				while(pos)
				{
					int iSel=GetNextSelectedItem(pos);
					itemdata=(sfl_itemdata*)GetItemData(iSel);
					file=itemdata->knownFile;
					if(itemdata->isFile==false)
					{
						if(file->IsPartFile()==false) 
						{
							file->SetPartStatus(itemdata->part, setTo);
							switch(setTo)
							{
								case PR_PART_ON:
									SetItemText(iSel, SFL_COLUMN_PRIORITY, "");
									break;

								case PR_PART_OFF:
									SetItemText(iSel, SFL_COLUMN_PRIORITY, "blocked");
									break;

								case PR_PART_HIDDEN:
									SetItemText(iSel, SFL_COLUMN_PRIORITY, "hidden");
									break;
							}
						}
					}
				}	
				RedrawItems(0, GetItemCount());
			}
			break;
		//--- :xrmb ---

		case MP_PERMNONE:
			if (((CPartFile*)file)->IsPartFile())
				AfxMessageBox(GetResString(IDS_ERR_NOPRIMCHANGE));
			else
			{	
				file->SetPermissions(PERM_NOONE);
				SetItemText(iSel,SFL_COLUMN_PERMISSION,GetResString(IDS_HIDDEN));
			}
			break;

		case MP_PERMFRIENDS:
			if (((CPartFile*)file)->IsPartFile())
				AfxMessageBox(GetResString(IDS_ERR_NOPRIMCHANGE));
			else
			{	
				file->SetPermissions(PERM_FRIENDS);
				SetItemText(iSel,SFL_COLUMN_PERMISSION,GetResString(IDS_FSTATUS_FRIENDSONLY));	
			}
			break;

		case MP_PERMALL:
			file->SetPermissions(PERM_ALL);
			SetItemText(iSel, SFL_COLUMN_PERMISSION, GetResString(IDS_FSTATUS_PUBLIC));
			break;
#if JUMPSTART
        case MP_JUMPSTART:
            if(file->GetJumpstartEnabled()) {
                if(AfxMessageBox(GetResString(IDS_JS_DISABLE)
                    ,MB_YESNO|MB_ICONEXCLAMATION|MB_DEFBUTTON2) == IDYES) {
                        file->SetJumpstartEnabled(false);
                }
            } else {
                if(file->IsJsComplete()) {
                    AfxMessageBox(GetResString(IDS_JS_COMPLETE), MB_OK|MB_ICONSTOP);
                } else {
                    file->SetJumpstartEnabled(true);
                }
            }
            break;
#endif
		default:
			if(m_pSCM)
				if(m_pSCM->IsMenuCommand(wParam))
					m_pSCM->InvokeCommand(wParam, file);
			break;
	}

	return true;

	EMULE_CATCH

	return false;
}

//--- i replaced the sorting, too much hassles ---
void CSharedFilesCtrl::OnColumnClick( NMHDR* pNMHDR, LRESULT* pResult)
{
	EMULE_TRY

	NMLISTVIEW* pNMListView = (NMLISTVIEW*)pNMHDR;
	m_listSorter.clicked(pNMListView->iSubItem);
	SetSortArrow(pNMListView->iSubItem, m_listSorter.arrow());	
	
	m_sortParts=GetAsyncKeyState(VK_SHIFT) < 0;

	//AddLogLine(true, "sort column %i, direction %s, level %i", m_listSorter.selected(), m_listSorter.dir()?"ascending":"descending", m_listSorter.level());
	
	SortItems(&SortProc, (LPARAM)&m_listSorter);	
	*pResult = 0;

	EMULE_CATCH
}

int CSharedFilesCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	EMULE_TRY

	//--- it happens :( ---
	if(lParam1==NULL || lParam2==NULL || lParamSort==NULL)
		return 0;

	CListCtrlSorter*	listSorter=(CListCtrlSorter*)lParamSort;
	int tmp;	//Cax2 patch 05/01/03
	sfl_itemdata*	item1;
	sfl_itemdata*	item2;
	if(listSorter->dir())
	{ 
		item1=(sfl_itemdata*)lParam1;
		item2=(sfl_itemdata*)lParam2;	
	}
	else
	{
		item1=(sfl_itemdata*)lParam2;
		item2=(sfl_itemdata*)lParam1;	
	}

	CKnownFile* knownfile1=item1->knownFile;
	CKnownFile* knownfile2=item2->knownFile;	

	//--- it happens :( ---
	if(knownfile1==NULL || knownfile2==NULL)
	        	return 0; 

	//--- some parts to compare? and from same file ---
	if(item1->isFile==false && item2->isFile==false && item1->knownFile==item2->knownFile)
	{
		//--- shiftkey down ---
		if(theApp.glob_prefs->DoUsePT() && m_sortParts)		//Cax2 bugfix 09/01/03
		{
			switch(listSorter->level())
			{
				case 1:
					switch(listSorter->selected())
					{
						case SFL_COLUMN_TRANSFERED:
							{
								uint32 pt1=knownfile1->GetPartTraffic(item1->part, true);
								uint32 pt2=knownfile2->GetPartTraffic(item2->part, true);

								if(pt1==0 && pt2==0)
								{
									pt1=knownfile1->GetPartTraffic(item1->part);
									pt2=knownfile2->GetPartTraffic(item2->part);

									if(pt1==0 && pt2==0)
										return sortcmp(item1->part, item2->part);

									if(pt1==0)
										return listSorter->dir()?1:-1;

									if(pt2==0)
										return listSorter->dir()?-1:1;

									return sortcmp(pt1, pt2);
								}

								if(pt1==0)
									return listSorter->dir()?1:-1;

								if(pt2==0)
									return listSorter->dir()?-1:1;

								return sortcmp(pt1, pt2);
							}
							break;

						case SFL_COLUMN_PARTTRAFFIC:
						case SFL_COLUMN_UPLOADS:
							return sortcmp(knownfile1->statistic.GetCompletePartReleases(item1->part),
								       knownfile2->statistic.GetCompletePartReleases(item2->part));
							break;

						default:
							return sortcmp(item1->part, item2->part);
					}
					break;

				case 2:
					switch(listSorter->selected())
					{
						case SFL_COLUMN_TRANSFERED:
							{
								uint32 pt1=knownfile1->GetPartTraffic(item1->part);
								uint32 pt2=knownfile2->GetPartTraffic(item2->part);

								if(pt1==0 && pt2==0)
									return sortcmp(item1->part, item2->part);

								if(pt1==0)
									return listSorter->dir()?1:-1;

								if(pt2==0)
									return listSorter->dir()?-1:1;

								return sortcmp(pt1, pt2);
							}
							break;

						case SFL_COLUMN_PARTTRAFFIC:
						case SFL_COLUMN_UPLOADS:
							{
								double d1=(double)knownfile1->GetPartTraffic(item1->part)/knownfile1->GetPartSize(item1->part);
								double d2=(double)knownfile2->GetPartTraffic(item2->part)/knownfile2->GetPartSize(item2->part);

								return sortcmp(d1, d2);
							}

						default:  
								return sortcmp(item1->part, item2->part);
					}
					break;
			}
		}

		//--- no shift key down, no sorting ---
		else
		{
			if(listSorter->dir())
				return sortcmp(item1->part, item2->part);
			else
				return sortcmp(item2->part, item1->part);
		}
	}

	//--- some other compare ---
	else
	{
		switch(listSorter->level())
		{
			case 1:
				switch(listSorter->selected())
				{
					case SFL_COLUMN_FILENAME:
						return stricmp(knownfile1->GetFileName(), knownfile2->GetFileName());

					case SFL_COLUMN_FILESIZE:
						return sortcmp(knownfile1->GetFileSize(), knownfile2->GetFileSize());

					case SFL_COLUMN_TYPE:
						return stricmp(GetFiletypeByName(knownfile1->GetFileName()), GetFiletypeByName(knownfile2->GetFileName()));

					case SFL_COLUMN_PRIORITY:
						return sortcmp(m_p2p[knownfile1->GetPriority()], m_p2p[knownfile2->GetPriority()]);

					case SFL_COLUMN_PERMISSION:
						return sortcmp(knownfile1->GetPermissions(), knownfile2->GetPermissions());

					case SFL_COLUMN_FILEID:
						return memcmp(knownfile1->GetFileHash(), knownfile2->GetFileHash(), 16);

					case SFL_COLUMN_REQUESTS:
						tmp=sortcmp(knownfile1->statistic.GetRequests(), knownfile2->statistic.GetRequests());
						return (tmp!=0)?tmp:sortcmp(knownfile1->statistic.GetAllTimeRequests(), knownfile2->statistic.GetAllTimeRequests());

					case SFL_COLUMN_ACCEPTED:
						tmp=sortcmp(knownfile1->statistic.GetAccepts(), knownfile2->statistic.GetAccepts());
						return (tmp!=0)?tmp:sortcmp(knownfile1->statistic.GetAllTimeAccepts(), knownfile2->statistic.GetAllTimeAccepts());

					case SFL_COLUMN_TRANSFERED:
						tmp=sortcmp(knownfile1->statistic.GetTransfered(), knownfile2->statistic.GetTransfered());
						return (tmp!=0)?tmp:sortcmp(knownfile1->statistic.GetAllTimeTransfered(), knownfile2->statistic.GetAllTimeTransfered());

					case SFL_COLUMN_COMPLETESRC:
						return sortcmp(knownfile1->GetCompleteSourcesCount(), knownfile2->GetCompleteSourcesCount());	// netwolf: complete sources (zegzav )
					case SFL_COLUMN_PARTTRAFFIC:
					case SFL_COLUMN_UPLOADS:
						{
							tmp=sortcmp(knownfile1->statistic.GetCompleteReleases(), knownfile2->statistic.GetCompleteReleases());
							if (tmp!=0) return tmp;

							double d1=(double)knownfile1->statistic.GetAllTimeTransfered()/knownfile1->GetFileSize();
							double d2=(double)knownfile2->statistic.GetAllTimeTransfered()/knownfile2->GetFileSize();
							return sortcmp(d1, d2);
						}					}

			case 2:
				switch(listSorter->selected())
				{
					case SFL_COLUMN_REQUESTS:
						return sortcmp(knownfile1->statistic.GetAllTimeRequests(), knownfile2->statistic.GetAllTimeRequests());

					case SFL_COLUMN_ACCEPTED:
						return sortcmp(knownfile1->statistic.GetAllTimeAccepts(), knownfile2->statistic.GetAllTimeAccepts());

					case SFL_COLUMN_TRANSFERED:
						return sortcmp(knownfile1->statistic.GetAllTimeTransfered(), knownfile2->statistic.GetAllTimeTransfered());

					case SFL_COLUMN_COMPLETESRC:
						return sortcmp(knownfile1->GetCompleteSourcesAccuracy() + (knownfile1->GetCompleteSourcesCount() ? 1 : 0), knownfile2->GetCompleteSourcesAccuracy() + (knownfile2->GetCompleteSourcesCount() ? 1 : 0));	// netwolf: complete sources (zegzav )

					case SFL_COLUMN_PARTTRAFFIC:
					case SFL_COLUMN_UPLOADS:
						{
							double d1=(double)knownfile1->statistic.GetAllTimeTransfered()/knownfile1->GetFileSize();
							double d2=(double)knownfile2->statistic.GetAllTimeTransfered()/knownfile2->GetFileSize();

							return sortcmp(d1, d2);
						}
				}
		}
	}

	EMULE_CATCH

	return 0;
}

void CSharedFilesCtrl::UpdateItem(CKnownFile* toupdate, bool resort)
{
	if (!::IsWindow(m_hWnd))	//fix crash at exit [TwoBottle Mod]
		return;

	EMULE_TRY
	
	if(toupdate == NULL)
		return;

	sfl_itemdata*	itemdata;
	for(int i=0; i<GetItemCount(); i++)
	{
		itemdata=(sfl_itemdata*)GetItemData(i);
		if(itemdata->isFile && itemdata->knownFile==toupdate)
		{
			UpdateFile(toupdate, i, resort);
			Update(i);
			RedrawItems(i,i); // Lord KiRon
			//--- it creates a flickering for me ---
			//theApp.emuledlg->sharedfileswnd.Check4StatUpdate(toupdate);

			return;
		}
	}

	EMULE_CATCH
}

void CSharedFilesCtrl::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	EMULE_TRY

	if (!lpDrawItemStruct->itemData)
		return;

	sfl_itemdata*	itemdata=(sfl_itemdata*)lpDrawItemStruct->itemData;
	CKnownFile*		file=itemdata->knownFile;
	CDC* odc = CDC::FromHandle(lpDrawItemStruct->hDC);
	int iODC = odc->SaveDC();

	if((lpDrawItemStruct->itemAction | ODA_SELECT) &&
		(lpDrawItemStruct->itemState & ODS_SELECTED)) 
	{
		if(GetFocus()==this)
			odc->SetBkColor(m_crHighlight);
		else
			odc->SetBkColor(m_crNoHighlight);
	}  
	else
		odc->SetBkColor(GetBkColor());

	CMemDC dc(odc, &CRect(lpDrawItemStruct->rcItem));
	int iDC = dc.SaveDC();
	CFont	*oldFont=dc->SelectObject(GetFont());

	//--- xrmb:allyaknow ---
	if(m_allYaKnow)
	{
		if(file->GetSharedFile()==false)
			dc->SetTextColor(::GetSysColor(COLOR_GRAYTEXT));
		else
			dc->SetTextColor(::GetSysColor(COLOR_WINDOWTEXT));
	}
	//--- :xrmb ---
	else
	{
			dc->SetTextColor(::GetSysColor(COLOR_WINDOWTEXT));
	}

	RECT cur_rec;
	memcpy(&cur_rec, &lpDrawItemStruct->rcItem, sizeof(RECT));

	CHeaderCtrl *pHeaderCtrl = GetHeaderCtrl();
	int iCount = pHeaderCtrl->GetItemCount();

	//--- all 0.. columns ---
	for(int c = 0; c < iCount; c++)
//	for(int c=0; c<ColumnsTracked(); c++)
	{
		//--- get real column, may its moved ---
//		int cc=GetColumnColumn(c);
		int cc = pHeaderCtrl->OrderToIndex(c);

		//--- if the column is hidden, dont do anything ---
		if(IsColumnHidden(cc))
			continue;

 		if(cc)
			cur_rec.left = cur_rec.right;
		cur_rec.right = cur_rec.left + GetColumnWidth(cc);
		cur_rec.left += 4;

		//--- is it a file? ---
		if(itemdata->isFile)
		{
		//--- 0..8 are the emule classic columns ---
			switch(cc)
			{
				case SFL_COLUMN_FILENAME:
				case SFL_COLUMN_TYPE:
				case SFL_COLUMN_PRIORITY:
				case SFL_COLUMN_PERMISSION:
				case SFL_COLUMN_FILEID:
				case SFL_COLUMN_FILESIZE:
				case SFL_COLUMN_REQUESTS:
				case SFL_COLUMN_COMPLETESRC: //netwolf: complete sources
				case SFL_COLUMN_ACCEPTED:
				case SFL_COLUMN_TRANSFERED:
				case SFL_COLUMN_UPLOADS:
					dc->DrawText(GetItemText(lpDrawItemStruct->itemID, cc), -1, &cur_rec, DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX|DT_END_ELLIPSIS);    
                    break; 

				case SFL_COLUMN_PARTTRAFFIC:	//--- part traffic ---		
					if (theApp.glob_prefs->DoUsePT()) //Cax2 05/01/03
					{
						cur_rec.bottom--;
						cur_rec.top++;

						// added
						int iWidth = cur_rec.right - cur_rec.left-4; 
						int iHeight = cur_rec.bottom - cur_rec.top;

						if(iWidth>0)
						{
							/*
							//--- the bar is not initalized yet? ---
							if(itemdata->bar==(HBITMAP)NULL)
							VERIFY(itemdata->bar.CreateBitmap(1, 1, 1, 16, NULL)); 

							CDC cdcStatus; 
							HGDIOBJ hOldBitmap;
							cdcStatus.CreateCompatibleDC(dc);
							int cx=itemdata->bar.GetBitmapDimension().cx; 
							DWORD dwTicks = GetTickCount();
							if(itemdata->repaintBar && itemdata->updated+SFL_BARUPDATE<dwTicks || cx!=iWidth) 
							{
								itemdata->repaintBar=false;

								itemdata->bar.DeleteObject(); 
								itemdata->bar.CreateCompatibleBitmap(dc,  iWidth, iHeight); 
								itemdata->bar.SetBitmapDimension(iWidth,  iHeight); 
								hOldBitmap = cdcStatus.SelectObject(itemdata->bar); 

								RECT rec_status; 
								rec_status.left = 0; 
								rec_status.top = 0; 
								rec_status.bottom = iHeight; 
								rec_status.right = iWidth; 
								DrawStatusBarFile(&cdcStatus, &rec_status, file->statistic);

								//--- hui? why thats random :) ---
								itemdata->updated = dwTicks + (rand() % 128); 
							} 
							else 
								hOldBitmap = cdcStatus.SelectObject(itemdata->bar); 

							dc->BitBlt(cur_rec.left, cur_rec.top, iWidth, iHeight,  &cdcStatus, 0, 0, SRCCOPY); 
							cdcStatus.SelectObject(hOldBitmap);
							*/
							//--- old bar draw ---
							cdcStatus.CreateCompatibleDC(&dc); 

							//--- the bar is not initalized yet? ---
							if(status==(HBITMAP)NULL)
							{
								status.CreateCompatibleBitmap(&dc, iWidth, iHeight); 
								m_statusWidth=iWidth;
							}
							else
							{
								//--- lol GetBitmapDimension/SetBitmapDimension work with 0.1mm units??? is MS stupid or what? this is a screen, not a piece of paper! ---
								//if(status.GetBitmapDimension().cx!=iWidth) 
								//	status.SetBitmapDimension(iWidth, iHeight); 

								//--- the we do it this way ---
								if(iWidth!=m_statusWidth)
								{
									status.DeleteObject();
									status.CreateCompatibleBitmap(&dc, iWidth, iHeight); 
									m_statusWidth=iWidth;
								}
							}

							CBitmap *oldBitmap=cdcStatus.SelectObject(&status); 

							RECT rec_status; 
							rec_status.left = 0; 
							rec_status.top = 0; 
							rec_status.bottom = iHeight; 
							rec_status.right = iWidth; 
							if(DrawStatusBarFile(&cdcStatus, &rec_status, file->statistic))
								dc->BitBlt(cur_rec.left, cur_rec.top, iWidth, iHeight,  &cdcStatus, 0, 0, SRCCOPY); 

							cdcStatus.SelectObject(oldBitmap);

							cdcStatus.DeleteDC();
						}

						//added end
						cur_rec.bottom++;
						cur_rec.top--;
					}
					break;
			}
		}

		//--- it is a part of a file ---
		else
		{
			//--- 0..8 are the emule classic columns ---
			switch(cc)
			{
				case SFL_COLUMN_FILENAME:
					dc->DrawText(GetItemText(lpDrawItemStruct->itemID, cc), -1, &cur_rec, DT_RIGHT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX|DT_END_ELLIPSIS);
					break;

				case SFL_COLUMN_PRIORITY:
				case SFL_COLUMN_ACCEPTED:
				case SFL_COLUMN_TRANSFERED:
				case SFL_COLUMN_UPLOADS:
				case SFL_COLUMN_COMPLETESRC: // netwolf: complete sources (zegzav )
					dc->DrawText(GetItemText(lpDrawItemStruct->itemID, cc), -1, &cur_rec, /*DT_RIGHT*/DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX|DT_END_ELLIPSIS);
					break;

				case SFL_COLUMN_PARTTRAFFIC:	//--- part traffic ---		
					if (theApp.glob_prefs->DoUsePT())	//Cax2 05/01/03
					{
						cur_rec.bottom--;
						cur_rec.top++;

						// added
						int iWidth = cur_rec.right - cur_rec.left-4; 
						int iHeight = cur_rec.bottom - cur_rec.top;

						if(iWidth>0)
						{
							/*--- this new code seems to waste more resources ---
							//--- the bar is not initalized yet? ---
							if(itemdata->bar==(HBITMAP)NULL)
								VERIFY(itemdata->bar.CreateBitmap(1, 1, 1, 16, NULL)); 

							CDC cdcStatus; 
							HGDIOBJ hOldBitmap;
							cdcStatus.CreateCompatibleDC(dc);
							int cx=itemdata->bar.GetBitmapDimension().cx; 
							DWORD dwTicks = GetTickCount();
							if(itemdata->repaintBar && itemdata->updated+SFL_BARUPDATE<dwTicks || cx!=iWidth) 
							{
								itemdata->repaintBar=false;

								itemdata->bar.DeleteObject(); 
								itemdata->bar.CreateCompatibleBitmap(dc,  iWidth, iHeight); 
								itemdata->bar.SetBitmapDimension(iWidth,  iHeight); 
								hOldBitmap = cdcStatus.SelectObject(itemdata->bar); 

								RECT rec_status; 
								rec_status.left = 0; 
								rec_status.top = 0; 
								rec_status.bottom = iHeight; 
								rec_status.right = iWidth; 
								DrawStatusBarPart(&cdcStatus, &rec_status, file->statistic, itemdata->part);

								//--- hui? why thats random :) ---
								itemdata->updated = dwTicks + (rand() % 128); 
							} 
							else 
								hOldBitmap = cdcStatus.SelectObject(itemdata->bar); 

							dc->BitBlt(cur_rec.left, cur_rec.top, iWidth, iHeight,  &cdcStatus, 0, 0, SRCCOPY); 
							cdcStatus.SelectObject(hOldBitmap);
							*/

							//--- old bar draw ---
							cdcStatus.CreateCompatibleDC(&dc); 

							//--- the bar is not initalized yet? ---
							if(status==(HBITMAP)NULL)
							{
								status.CreateCompatibleBitmap(&dc, iWidth, iHeight); 
								m_statusWidth=iWidth;
							}
							else
							{
							//--- lol GetBitmapDimension/SetBitmapDimension work with 0.1mm units??? is MS stupid or what? this is a screen, not a piece of paper! ---
							//if(status.GetBitmapDimension().cx!=iWidth) 
							//	status.SetBitmapDimension(iWidth, iHeight); 

							//--- the we do it this way ---
							if(iWidth!=m_statusWidth)
							{
								status.DeleteObject();
								status.CreateCompatibleBitmap(&dc, iWidth, iHeight); 
								m_statusWidth=iWidth;
							}
							}
							CBitmap *oldBitmap=cdcStatus.SelectObject(&status); 

							RECT rec_status; 
							rec_status.left = 0; 
							rec_status.top = 0; 
							rec_status.bottom = iHeight; 
							rec_status.right = iWidth; 
							if(DrawStatusBarPart(&cdcStatus, &rec_status, file->statistic, itemdata->part))
								dc->BitBlt(cur_rec.left, cur_rec.top, iWidth, iHeight, &cdcStatus, 0, 0, SRCCOPY); 

							cdcStatus.SelectObject(oldBitmap);

							cdcStatus.DeleteDC();
						}

						//added end
						cur_rec.bottom++;
						cur_rec.top--;
					}
					break;
			}
		}
	}

	//--- draw rectangle around selected item ---
	if(lpDrawItemStruct->itemState & ODS_FOCUS)
	{
		RECT focus_rec;
		focus_rec.top    = lpDrawItemStruct->rcItem.top;
		focus_rec.bottom = lpDrawItemStruct->rcItem.bottom;
		focus_rec.left   = lpDrawItemStruct->rcItem.left + 1;
		focus_rec.right  = lpDrawItemStruct->rcItem.right - 1;
		if(GetFocus()==this)
		{
			brush.CreateSolidBrush(m_crFocusLine);
			dc->FrameRect(&focus_rec, &brush);
		}
		else
		{
			brush.CreateSolidBrush(m_crNoFocusLine);
			dc->FrameRect(&focus_rec, &brush);
		}
		brush.DeleteObject();
	}

	dc->SelectObject(oldFont);
	dc.RestoreDC(iDC);
	odc->RestoreDC(iODC);

	EMULE_CATCH
}

bool CSharedFilesCtrl::DrawStatusBarFile(CDC* dc, RECT* rect, const CFileStatistic& statistic)
{ 
	EMULE_TRY

	int	available, use;
	available=use=(rect->right-rect->left+1);
	uint32	fs=statistic.fileParent->GetFileSize();
	if(fs<PARTSIZE)
		use=max(1, available*((double)fs/PARTSIZE));

	RECT r;
	r.top=rect->top;
	r.bottom=rect->bottom;
	r.left=rect->left;
	r.right=rect->right;

	if(available==use)
	{
		brush.CreateSolidBrush(RGB(0x00, 0x00, 0x00));
		dc->FillRect(rect, &brush);
		brush.DeleteObject();
	}
	else
	{
		r.right=r.left+use;
		brush.CreateSolidBrush(RGB(0x00, 0x00, 0x00));
		dc->FillRect(&r, &brush);
		brush.DeleteObject();

		r.left=r.right;
		r.right=available;
		brush.CreateSolidBrush(RGB(0xCC, 0xCC, 0xCC));
		dc->FillRect(&r, &brush);
		brush.DeleteObject();
	}

	if(statistic.GetAllTimeTransfered()==0 || statistic.partTraffic==NULL)
		return true;

	double bpp=(double)fs/use;

	//--- traffigram? ---
	if(m_trafficgram)
	{
		TraffiGram(dc, rect, statistic, use, bpp);
	}

	//--- old boring bar style :) ---
	else
	{
		uint32	t;	// traffic

		for(int x=0; x<use; x++)
		{
			//--- xrmb:partprio ---
			bool	boh=statistic.fileParent->GetPartStatus(x*bpp/PARTSIZE)!=PR_PART_ON;
			//--- :xrmb ---

			//--- draw alltime parttraffic bar? ---
			if(m_display_atpte)
			{
				t=statistic.fileParent->GetTrafficPart(x*bpp, (x+1)*bpp);
				if(t)
				{
					pen.CreatePen(PS_SOLID, 0, GrayIt(boh, GetTrafficColor(t/bpp)));
					CPen *pOldPen = dc->SelectObject(&pen);
					dc->MoveTo(x, m_display_atpts);
					dc->LineTo(x, m_display_atpte);
					dc->SelectObject(pOldPen);		// FoRcHa
					pen.DeleteObject();
				}
			}

			//--- draw alltime blocktraffic bar? ---
			if(m_display_atbte)
			{
				t=statistic.fileParent->GetTrafficBlock(x*bpp, (x+1)*bpp);
				if(t)
				{
					pen.CreatePen(PS_SOLID, 0, GrayIt(boh, GetTrafficColor(t/bpp)));
					CPen *pOldPen = dc->SelectObject(&pen);
					dc->MoveTo(x, m_display_atbts);
					dc->LineTo(x, m_display_atbte);
					dc->SelectObject(pOldPen);		// FoRcHa
					pen.DeleteObject();
				}
			}

			//--- draw session blocktraffic bar? ---
			if(m_display_sbte)
			{
				t=statistic.fileParent->GetTrafficBlock(x*bpp, (x+1)*bpp, true);
				if(t)
				{
					pen.CreatePen(PS_SOLID, 0, GrayIt(boh, GetTrafficColor(t/bpp)));
					CPen *pOldPen = dc->SelectObject(&pen);
					dc->MoveTo(x, m_display_sbts);
					dc->LineTo(x, m_display_sbte);
					dc->SelectObject(pOldPen);		// FoRcHa
					pen.DeleteObject();
				}
			}
		}
	}

	return true;

	EMULE_CATCH

	return false;
} 

bool CSharedFilesCtrl::DrawStatusBarPart(CDC* dc, RECT* rect, const CFileStatistic& statistic, uint16 part)
{ 
	EMULE_TRY

	uint32 ps=statistic.fileParent->GetPartSize(part);

	RECT r;
	r.top=rect->top;
	r.bottom=rect->bottom;
	r.left=rect->left;
	r.right=rect->right;

	int use=max(1, (int)(rect->right - rect->left + 1)*((double)ps/PARTSIZE));

	if(ps!=PARTSIZE)
	{
		r.right=r.left+use;
		brush.CreateSolidBrush(RGB(0x00, 0x00, 0x00));
		dc->FillRect(&r, &brush);
		brush.DeleteObject();

		r.left=r.right;
		r.right=rect->right;
		brush.CreateSolidBrush(RGB(0xCC, 0xCC, 0xCC));
		dc->FillRect(&r, &brush);
		brush.DeleteObject();
	}
	else
	{
		brush.CreateSolidBrush(RGB(0x00, 0x00, 0x00));
		dc->FillRect(rect, &brush);
		brush.DeleteObject();
	}

	if(statistic.partTraffic==NULL || statistic.partTraffic[part]==0)
		return true;

	uint32 start=part*PARTSIZE;
	double bpp=(double)ps/use;

	//--- traffigram? ---
	if(m_trafficgram)
	{
		TraffiGram(dc, rect, statistic, use, bpp, start);
	}

	//--- old boring bar style :) ---
	else
	{
		uint32 t;

		//--- draw alltime parttraffic bar? ---
		if(m_display_atpte)
		{
			t=statistic.fileParent->GetPartTraffic(part);
			if(t)
			{
				r.top=m_display_atpts;
				r.bottom=m_display_atpte;
				r.left=rect->left;
				r.right=rect->left+use;
				brush.CreateSolidBrush(GetTrafficColor((float)t/ps));
				dc->FillRect(&r, &brush);
				brush.DeleteObject();
				r.bottom=rect->bottom;
			}
		}

		for(int x=0; x<use; x++)
		{
			//--- draw alltime blocktraffic bar? ---
			if(m_display_atbte)
			{
				t=statistic.fileParent->GetTrafficBlock(start+x*bpp, start+(x+1)*bpp);
				if(t)
				{
					pen.CreatePen(PS_SOLID, 0, GetTrafficColor(t/bpp));
					CPen *pOldPen = dc->SelectObject(&pen);
					dc->MoveTo(x, m_display_atbts);
					dc->LineTo(x, m_display_atbte);
					dc->SelectObject(pOldPen);		// FoRcHa
					pen.DeleteObject();
				}
			}

			//--- draw session blocktraffic bar? ---
			if(m_display_sbte)
			{
				t=statistic.fileParent->GetTrafficBlock(start+x*bpp, start+(x+1)*bpp, true);
				if(t)
				{
					pen.CreatePen(PS_SOLID, 0, GetTrafficColor(t/bpp));
					CPen *pOldPen = dc->SelectObject(&pen);
					dc->MoveTo(x, m_display_sbts);
					dc->LineTo(x, m_display_sbte);
					dc->SelectObject(pOldPen);		// FoRcHa
					pen.DeleteObject();
				}
			}
		}
	}

	return true;

	EMULE_CATCH

	return false;
} 

void CSharedFilesCtrl::OnDoubleClick(NMHDR* pNMHDR, LRESULT* pResult)
{
	EMULE_TRY

	NMITEMACTIVATE *i=(NMITEMACTIVATE*)pNMHDR;

    if(i->iItem == -1)
        return;

	//--- if shift+dblclk hide all no traffic parts ---
	bool	onlyWithTraffic=i->uKeyFlags & LVKF_SHIFT;
	bool	onlyWithSessionTraffic=i->uKeyFlags & LVKF_SHIFT && i->uKeyFlags & LVKF_CONTROL;

	//--- get data from double clicked item ---
	sfl_itemdata	*itemdataParent=(sfl_itemdata*)GetItemData(i->iItem);

	//--- is it a file? ---
	if(itemdataParent->isFile==false)
	{
		switch(i->iSubItem)
		{
			case SFL_COLUMN_PRIORITY:
				{
					//--- no blocking and hidding for partfiles! ---
					if(itemdataParent->knownFile->IsPartFile())
						break;

					int setTo=MP_SFL_PARTON;
					switch(itemdataParent->knownFile->GetPartStatus(itemdataParent->part))
					{
						case PR_PART_ON:
							setTo=PR_PART_HIDDEN;
							break;
						case PR_PART_HIDDEN:
							setTo=PR_PART_OFF;
							break;
						case PR_PART_OFF:
						default:
							setTo=PR_PART_ON;
							break;
					}
					itemdataParent->knownFile->SetPartStatus(itemdataParent->part, setTo);
					UpdateItem(itemdataParent->knownFile);
				}
				break;
		}
		return;
	}

	CKnownFile	*file=itemdataParent->knownFile;

	//--- toggle open ---
	itemdataParent->isOpen=!itemdataParent->isOpen;

	//--- is this file already open? ---
	//!!! ATTN i toggled isOpen already... you will not understand why I did this :) ---
	if(itemdataParent->isOpen==false)
	{
		SetRedraw(false);

		//--- delete all part-childs ---
		for(uint16 part=0; part<itemdataParent->parts; part++)
		{
			sfl_itemdata *itemdata=(sfl_itemdata*)GetItemData(i->iItem+1);
			if (itemdata->isFile) break;	//Cax2 14/01/03	bugfix
			SetItemData(i->iItem+1, NULL);
			DeleteItem(i->iItem+1);
			if(itemdata) delete itemdata;
		}

		SetRedraw(true);
	}

	//--- it is not open ---
	else
	{
		if(theApp.glob_prefs->DoUsePT() && file->GetPartCount()>1)	//Cax2 05/01/03
		{
			char	buffer[20];
			uint16	parts=0;
			
			SetRedraw(false);

			for(uint16 part=0; part<file->GetPartCount(); part++)
			{
				//--- no no traffic items? ---
				if(onlyWithTraffic && file->GetPartTraffic(part, onlyWithSessionTraffic)==0)
					continue;

				parts++;

				sfl_itemdata	*itemdata=new sfl_itemdata;
				itemdata->isFile=false;
				itemdata->isOpen=false;
				itemdata->knownFile=file;
				itemdata->part=part;
				itemdata->parts=0;

				sprintf(buffer, "%i", part);
				InsertItem(LVIF_TEXT|LVIF_PARAM, i->iItem+parts, buffer, 0, 0, 0, (LPARAM)itemdata);
			}

			SetRedraw(true);

			itemdataParent->parts=parts;

			//--- no parts added? then we can close it ---
			if(parts==0)
				itemdataParent->isOpen=false;

			//--- ok, thats why i toggled the isOpen before :) ---
			UpdateFile(file, i->iItem);
		}
	}

	*pResult=0;

	EMULE_CATCH
}

void CSharedFilesCtrl::SetColoring(uint8 mode)
{
	EMULE_TRY

	switch(mode)
	{
	case 0:
		GetTrafficColor=&GetTrafficColor0;
		break;

	case 1:
		GetTrafficColor=&GetTrafficColor1;
		break;

	case 2:
		GetTrafficColor=&GetTrafficColor2;
		break;

	case 3:
		GetTrafficColor=&GetTrafficColor3;
		break;

	default:
		GetTrafficColor=&GetTrafficColor0;
	}

	EMULE_CATCH
}

void CSharedFilesCtrl::SetDisplay(uint8 mode, bool redraw)	
{
	EMULE_TRY

	m_display=mode; 

	//--- should be 17 pixel high, i hope that never changes, but i try to save cpu where i can ---

	switch(m_display)
	{
	case 1:
		m_display_atpts	= 0;
		m_display_atpte	= 4;
		m_display_atbts	= 5;
		m_display_atbte	= 16;
		m_display_sbts	= 0;
		m_display_sbte	= 0;
		m_trafficgram	= false;
		break;

	case 2:
		m_display_atpts	= 0;
		m_display_atpte	= 4;
		m_display_atbts	= 5;
		m_display_atbte	= 11;
		m_display_sbts	= 12;
		m_display_sbte	= 16;
		m_trafficgram	= false;
		break;

	case 3:	// traffigram
		m_trafficgram=true;
		break;

	case 0:
	default:
		m_display_atpts	= 0;
		m_display_atpte	= 16;
		m_display_atbts	= 0;
		m_display_atbte	= 0;
		m_display_sbts	= 0;
		m_display_sbte	= 0;

		m_trafficgram	= false;
	}

	if(redraw) 
		RedrawItems(0, GetItemCount());

	EMULE_CATCH
}

void CSharedFilesCtrl::TraffiGram(CDC* dc, RECT* rect, const CFileStatistic& statistic, int use, double bpp, uint32 start)
{
	EMULE_TRY

	uint32 tt=0;
	//--- needs highest value! ---
	for(int x=0; x<use; x++)
	{
		tt=max(tt, statistic.fileParent->GetTrafficBlock(start+x*bpp, start+(x+1)*bpp));
	}

	int h=rect->bottom-rect->top+1;	// height
	int	lh=0;		// last height
	int	ch=0;		// current height
	uint32	lt=0;	// last traffic
	uint32	tph=tt/h;	// traffic per height pixel
	uint32	t;
	for(int x=0; x<use; x++)
	{
		t=statistic.fileParent->GetTrafficBlock(start+x*bpp, start+(x+1)*bpp);
		ch=h-(int)(h*(float)t/tt+0.5);
		if(t) 
			dc->SetPixel(x, ch, GetTrafficColor(t/bpp));

		//--- fill space between last and now ---
		if(x && lh!=ch)
		{
			int d=1;
			if(lh>ch)
				d=-1;
			
			for(int i=1; i<abs(lh-ch)/2+1; i++)
			{
				dc->SetPixel(x-1,	lh+i*d, GetTrafficColor((tt-tph*(lh+i*d))/bpp));
				dc->SetPixel(x,		ch-i*d, GetTrafficColor((tt-tph*(ch-i*d))/bpp));
			}
		}

		lh=ch;
		lt=t;
	}

	EMULE_CATCH
}

COLORREF GetTrafficColor0(float f)
{
	//--- COLORING MODE 1 --- RAINBOW ---
	//--- 0..1   black to red ---
	if(f<1)
		return RGB((BYTE)(255*f), 0, 0);
	
	//--- 1..3   red to yellow ---
	if(f<3)
		return RGB(255, (uint8)(255*(f-1)/2.0), 0);

	//--- 3..6   yellow to green ---
	if(f<6)
		return RGB((uint8)(255*((6-f)/3.0)), 255, 0);

	//--- 6..10   green to cyan ---
	if(f<10)
		return RGB(0, 255, (uint8)(255*((f-6)/4.0)));

	//--- 10..15   cyan to blue ---
	if(f<15)
		return RGB(0, (uint8)(255*((15-f)/5.0)), 255);

	//--- 15..21   blue to pink ---
	if(f<21)
		return RGB((uint8)(255*((f-15)/6.0)), 0, 255);

	//--- 21..28   pink to white ---
	if(f<28)
		return RGB(255, (uint8)(255*((28-f)/7.0)), 255);

	return RGB(255, 255, 255);
}

COLORREF GetTrafficColor1(float f)
{
	//--- COLORING MODE 1 --- RAINBOW ---
	//--- 0..1   black to red ---
	if(f<1)
		return RGB((BYTE)(255*f), 0, 0);
	
	//--- 1..2   red to yellow ---
	if(f<2)
		return RGB(255, (uint8)(255*(f-1)), 0);

	//--- 2..3   yellow to green ---
	if(f<3)
		return RGB((uint8)(255*((3-f))), 255, 0);

	//--- 3..4   green to cyan ---
	if(f<4)
		return RGB(0, 255, (uint8)(255*((f-3))));

	//--- 4..5   cyan to blue ---
	if(f<5)
		return RGB(0, (uint8)(255*((5-f))), 255);

	//--- 5..6   blue to pink ---
	if(f<6)
		return RGB((uint8)(255*((f-5))), 0, 255);

	//--- 6..7   pink to white ---
	if(f<7)
		return RGB(255, (uint8)(255*((7-f))), 255);

	return RGB(255, 255, 255);
}

COLORREF GetTrafficColor2(float f)
{
	//--- COLORING MODE 2 --- like in download ---
	return RGB(0, (210-(22*(f-1)) <  0)? 0:210-(22*(f-1)), 255);	
}

COLORREF GetTrafficColor3(float f)
{
	//--- girlie mode ---
	return RGB(255, 0, (210-(22*(f-1)) <  0)? 0:210-(22*(f-1)));	
}
//--- :xrmb ---

void CSharedFilesCtrl::ShowFilesCount() {
	CString counter;
	counter.Format(" (%i)",GetItemCount() );
	theApp.emuledlg->sharedfileswnd.GetDlgItem(IDC_TRAFFIC_TEXT)->SetWindowText(GetResString(IDS_SF_FILES)+counter  );
}