//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// emuleDlg.h : Headerdatei
//
#pragma once
#include "sockets.h"
#include "afxcmn.h"
#include "afxwin.h"
#include "serverlistctrl.h"
#include "knownfilelist.h"
#include "TransferWnd.h"
#include "ServerWnd.h"
#include "Preferencesdlg.h"
#include "SharedFilesWnd.h"
#include "SearchDlg.h"
#include "ChatWnd.h"
#include "traydialog.h"
#include "BtnST.h"
#include "StatisticsDlg.h"
#include "MeterIcon.h"
#include "MuleToolBarCtrl.h"
#include "PreferencesDlg.h"
#include "afxdlgs.h"
#include "aboutdlg.h"
#include "ThemeHelperST.h"
#include "IrcWnd.h"
#include "TaskbarNotifier.h"
#include "WebServer.h" // kuchin
#include "MuleSystrayDlg.h"
#include "loggable.h"

#define MP_RESTORE		4001
#define MP_CONNECT		4002
#define MP_DISCONNECT	4003
#define MP_EXIT			4004

/* --obaldin: it lives in theApp
enum APPState {APP_STATE_RUNNING=0,
			   APP_STATE_SHUTINGDOWN,
			   APP_STATE_DONE
};
*/

class CKnownFileList; 
// CemuleDlg Dialogfeld
class CemuleDlg : public CTrayDialog, public CLoggable
{
friend class CMuleToolbarCtrl;
// Konstruktion
public:
	CemuleDlg(CWnd* pParent = NULL);	// Standardkonstruktor
	~CemuleDlg();
	enum { IDD = IDD_EMULE_DIALOG };

	void			AddServerMessageLine(char* line,...);
	void			AddBugReport(LPCTSTR sFile, long nLine, CString msg);

//[TwoBottle Mod]
	void			AddLogText(bool addtostatusbar,const CString& txt,bool bDebug=false);
	//void			AddDebugLogText(bool addtostatusbar,const CString& txt);

	void			ShowConnectionState();
	void			ShowConnectionState(bool connected);
	void			ShowConnectionState(bool connected,CString server,bool iconOnly=false);
	void			ShowNotifier(CString Text, int MsgType, bool ForceSoundOFF = false); 
	void			ShowUserCount(uint32 users_toshow, uint32 files_toshow);
	void			ShowMessageState(uint8 iconnr);
	void			SetActiveDialog(CDialog* dlg);
	void			ShowTransferRate(bool bUpdateAll = true);
	void			ShowStatistics();
	void			Localize();
	void			ResetLog();
	void			ResetDebugLog();
	void			ResizeStatusBar();
	// Barry - To find out if app is running or shutting/shut down
	bool			IsRunning();

	CTransferWnd		transferwnd;
	CServerWnd			serverwnd;
	CPreferencesDlg		preferenceswnd;
	CSharedFilesWnd		sharedfileswnd;
	CSearchDlg			searchwnd;
	CChatWnd			chatwnd;
	CStatusBarCtrl   	statusbar;
	CMuleToolbarCtrl 	toolbar;
#ifdef USE_REBAR
	CReBarCtrl          rebar;
#endif
	CDialog*			activewnd;
	CStatisticsDlg  	statisticswnd;
	CIrcWnd				ircwnd;
	CTaskbarNotifier 	m_wndTaskbarNotifier;
	//APPState			m_app_state; --obaldin: it lives in theApp
	uint8				status;
	CRect				m_rClientRect;
	CThemeHelperST		m_ThemeHelper;
	CFont				m_DefaultFont;
protected:
	HICON m_hIcon;
	virtual void DoDataExchange(CDataExchange* pDX);
	virtual BOOL OnInitDialog();
	virtual void OnTrayRButtonDown(CPoint pt);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);

	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnBnClickedButton2();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
		
	// quick-speed changer -- based on xrmb
	//afx_msg void QuickSpeedUpload(UINT nID);
	//afx_msg void QuickSpeedDownload(UINT nID);
	void QuickSpeedOther(UINT nID);
	// end of quick-speed changer

	//kuchin
	afx_msg LRESULT OnWebServerConnect(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnWebServerRemove(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnWebSharedFilesReload(WPARAM wParam, LPARAM lParam);


	afx_msg LRESULT OnTaskbarNotifierClicked(WPARAM wParam,LPARAM lParam);
	afx_msg LRESULT OnWMData(WPARAM wParam,LPARAM lParam);
	afx_msg LRESULT OnFileHashed(WPARAM wParam,LPARAM lParam);
	afx_msg LRESULT OnAreYouEmule(WPARAM, LPARAM);

	virtual void OnSize(UINT nType,int cx,int cy);
	void		 OnOK()			{}
	void		 OnClose();
	void		 OnCancel();
	void		 DisConnect();

	DECLARE_MESSAGE_MAP()
private:
	CMutex 	critical_log_section; // i_a patch
	CString			logtext;
	CString			debuglog;
	bool			ready,startUpMinimized;	
	HICON			connicons[3];
	HICON			transicons[4];
	HICON			imicons[3];
	HICON			mytrayIcon;
	HICON			usersicon;
	
	CMeterIcon 		trayIcon;
	HICON 			sourceTrayIcon;
	HICON 			sourceTrayIconLowID;
	HICON 			sourceTrayIconGrey;

	uint32			lastuprate;
	uint32			lastdownrate;
	CImageList		imagelist;
	CTitleMenu		trayPopup;
	CMuleSystrayDlg *m_pSystrayDlg;
	
	UINT_PTR m_hTimer;
	static void CALLBACK Timer(HWND hwnd, UINT uiMsg, UINT idEvent, DWORD dwTime);

	void 			StartConnection();
	void 			CloseConnection();
	void 			RestoreWindow();
	void 			UpdateTrayIcon(int procent);
	void 			AddSpeedSelectorSys(CMenu* addToMenu);
	int  			GetRecMaxUpload();
	
	friend class 		CWebServer; // kuchin

public: 
   afx_msg BOOL OnQueryEndSession();
   afx_msg void OnNcDestroy();
   BOOL TrayShow(void);
};
